﻿--Глобальный массив аддона "Chaos Bolt DPET Tracker"
CBDT = {}

--Параметры командной строки
SLASH_CBDT1 = "/cbdt"

--Название и версия аддона
CBDT.ADDON_NAME = "Chaos Bolt DPET Tracker"
CBDT.ADDON_VERSION = "r19-wow-20444"

--Параметры частоты обновления
CBDT.UpdateInterval         = 0.1
CBDT.TimeSinceLastUpdate    = 0

--Аддон включен/отключен
CBDT.IsEnabled              = true

--Отладочные сообщения
CBDT.IsDebugEnabled         = false

--Использовать симуляцию баффов
CBDT.IsBuffSimulationEnabled = false

--Использовать режим тестирования
CBDT.IsTestModeEnabled       = false

--Player spec definitions
CBDT.SPEC_NONE            = 0
CBDT.SPEC_PET             = 1
CBDT.PET_FEROCITY         = 74
CBDT.PET_TENACITY         = 81
CBDT.PET_CUNNING          = 79
CBDT.WARRIOR_ARMS         = 71
CBDT.WARRIOR_FURY         = 72
CBDT.WARRIOR_PROTECTION   = 73
CBDT.PALADIN_HOLY         = 65
CBDT.PALADIN_PROTECTION   = 66
CBDT.PALADIN_RETRIBUTION  = 70
CBDT.HUNTER_BEAST_MASTERY = 253
CBDT.HUNTER_MARKSMANSHIP  = 254
CBDT.HUNTER_SURVIVAL      = 255
CBDT.ROGUE_ASSASSINATION  = 259
CBDT.ROGUE_COMBAT         = 260
CBDT.ROGUE_SUBTLETY       = 261
CBDT.PRIEST_DISCIPLINE    = 256
CBDT.PRIEST_HOLY          = 257
CBDT.PRIEST_SHADOW        = 258
CBDT.DEATH_KNIGHT_BLOOD   = 250
CBDT.DEATH_KNIGHT_FROST   = 251
CBDT.DEATH_KNIGHT_UNHOLY  = 252
CBDT.SHAMAN_ELEMENTAL     = 262
CBDT.SHAMAN_ENHANCEMENT   = 263
CBDT.SHAMAN_RESTORATION   = 264
CBDT.MAGE_ARCANE          = 62
CBDT.MAGE_FIRE            = 63
CBDT.MAGE_FROST           = 64
CBDT.WARLOCK_AFFLICTION   = 265
CBDT.WARLOCK_DEMONOLOGY   = 266
CBDT.WARLOCK_DESTRUCTION  = 267
CBDT.MONK_BREWMASTER      = 268
CBDT.MONK_MISTWEAVER      = 270
CBDT.MONK_WINDWALKER      = 269
CBDT.DRUID_BALANCE        = 102
CBDT.DRUID_FERAL          = 103
CBDT.DRUID_GUARDIAN       = 104
CBDT.DRUID_RESTORATION    = 105

--Spell effect Types definition
local A_MOD_STAT                                = 29
local A_MOD_CRITICAL_HEALING_AMOUNT             = 50
local A_MOD_RATING                              = 189
local A_MOD_DAMAGE_PERCENT_DONE                 = 79
local A_MOD_CRIT_DAMAGE_BONUS                   = 163
local A_MOD_TOTAL_STAT_PERCENTAGE               = 137
local A_MOD_HASTE                               = 193
local A_MOD_SPELL_POWER_PERCENTAGE              = 317
local A_MOD_RATING_PERCENTAGE                   = 405
local A_MOD_MULTISTRIKE_PERCENTAGE              = 441
local A_MOD_ATTACK_POWER_PERCENTAGE             = 166
local A_MOD_RANGED_ATTACK_POWER_PERCENTAGE      = 167
local A_MOD_ALL_CRIT_PERCENTAGE                 = 290
local A_MOD_VERSATILITY_PERCENTAGE              = 471
local A_ADD_FLAT_MODIFIER                       = 107
local A_MOD_ALL_MASTERY_PERCENTAGE              = 318
local A_MOD_SPELL_POWER                         = 13
local A_MOD_RANGED_ATTACK_POWER                 = 124
local A_MOD_ATTACK_POWER                        = 99
local A_MOD_SPELL_CRIT_CHANCE                   = 57
local A_MOD_PERCENT_STAT                        = 80
local A_MOD_ATTACK_SPEED_PERCENTAGE             = 342
local A_ADD_PERCENTAGE_MODIFIER                 = 108
local A_MOD_CASTING_SPEED_NOT_STACK             = 65
local A_MOD_SPELL_CRITICAL_STRIKE_PERCENTAGE    = 308

--Item quality constants
local ITEM_QUALITY_POOR         = 0
local ITEM_QUALITY_COMMON       = 1
local ITEM_QUALITY_UNCOMMON     = 2
local ITEM_QUALITY_RARE         = 3
local ITEM_QUALITY_EPIC         = 4
local ITEM_QUALITY_LEGENDARY    = 5
local ITEM_QUALITY_ARTIFACT     = 6
local ITEM_QUALITY_HEIRLOOM     = 7

--Item bonuses types
local ITEM_BONUS_ILEVEL    = 1
local ITEM_BONUS_MOD       = 2
local ITEM_BONUS_DESC      = 4
local ITEM_BONUS_SUFFIX    = 5
local ITEM_BONUS_SOCKET    = 6
local ITEM_BONUS_REQ_LEVEL = 8
local ITEM_BONUS_SCALING   = 11

--Spell effect stat/rating increase Type definition
local TYPE_UNKNOWN      = 0
local TYPE_FLAT         = 1
local TYPE_PERCENTAGE   = 2
local MODE_ADD          = 1
local MODE_MULT         = 2
local INDEX_MODE_DIRECT = 1
local INDEX_MODE_MASK   = 2
local INDEX_MODE_ANY    = 3

--UnitAura keys definition
local UNIT_AURA_NAME          = 1
local UNIT_AURA_STACKS        = 4
local UNIT_AURA_DURATION      = 6
local UNIT_AURA_EXPIRES       = 7
local UNIT_AURA_SPELL_ID      = 11
local UNIT_AURA_VALUE_OFFSET  = 15

--Target override "player"/"target"
local SelectedUnit = "player"

--DPET spells definition
local DPET_CHAOS_BOLT_SPELL_ID  = 116858
local DPET_SHADOW_BURN_SPELL_ID = 17877
local DPET_INCINERATE_SPELL_ID  = 29722
local DPET_NO_SPELL_ID          = 0

--Notification sound replay event sources
local NSR_NO_SOURCE             = 0
local NSR_TARGET_CHANGED        = 1
local NSR_INTERRUPTED_SPELLCAST = 2
local NSR_SUCCEEDED_SPELLCAST   = 3
local NSR_EMBER_CAP_CHAOS_BOLT  = 4
local NSR_EMBER_CAP_SHADOWBURN  = 5
local NSR_EMBER_KILL_CHAOS_BOLT = 6
local NSR_EMBER_KILL_SHADOWBURN = 7
local NSR_DPET_LEVEL_CHAOS_BOLT = 8
local NSR_DPET_LEVEL_SHADOWBURN = 9
local NSR_HAVOC_CHAOS_BOLT      = 10
local NSR_HAVOC_SHADOWBURN      = 11
local NSR_STAND_STILL           = 12

--DPET levels definition
local DPET_NO_LEVEL             = 0
local DPET_LOW_LEVEL            = 1
local DPET_HIGH_LEVEL           = 2

--Active|Inactive color definition
local COLOR_NOT_SET     = 0
local COLOR_INACTIVE    = 1
local COLOR_ACTIVE      = 2
local COLOR_TRANSPARENT = 3

--Player stats and ratings definition
local PSR_ALL_STATS                 = -1
local PSR_STRENGTH                  = 1
local PSR_AGILITY                   = 2
local PSR_STAMINA                   = 3
local PSR_INTELLECT                 = 4
local PSR_SPIRIT                    = 5
local PSR_CRIT_DAMAGE_BONUS         = 10
local PSR_CRIT_HEALING_BONUS        = 11
local PSR_DAMAGE_DONE_BONUS         = 12
local PSR_DODGE                     = 20
local PSR_PARRY                     = 21
local PSR_HIT_MELEE                 = 22
local PSR_HIT_RANGED                = 23
local PSR_HIT_SPELL                 = 24
local PSR_HIT                       = 25
local PSR_CRIT_MELEE                = 26
local PSR_CRIT_RANGED               = 27
local PSR_CRIT_SPELL                = 28
local PSR_CRIT                      = 29
local PSR_MULTISTRIKE               = 30
local PSR_READINESS                 = 31
local PSR_SPEED                     = 32
local PSR_PVP_RESILIENCE            = 33
local PSR_LEECH                     = 34
local PSR_HASTE_MELEE               = 35
local PSR_HASTE_RANGED              = 36
local PSR_HASTE_SPELL               = 37
local PSR_HASTE                     = 38
local PSR_EXPERTISE                 = 39
local PSR_MASTERY                   = 40
local PSR_PVP_POWER                 = 41
local PSR_VERSATILITY_DAMAGE        = 42
local PSR_VERSATILITY_HEALING       = 43
local PSR_VERSATILITY_MITIGATION    = 44
local PSR_VERSATILITY               = 45
local PSR_SPELL_POWER               = 46
local PSR_ATTACK_POWER              = 47
local PSR_ATTACK_POWER_RANGED       = 48
local PSR_ATTACK_SPEED              = 49
local SSR_CAST_TIME_PERCENTAGE      = 50
local SSR_CAST_TIME_FLAT            = 51

CBDT.Player = {
    Stats = {
        [PSR_STRENGTH]              = { Name = "STRENGTH           "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_FLAT,       Mode = MODE_ADD,  BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_AGILITY]               = { Name = "AGILITY            "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_FLAT,       Mode = MODE_ADD,  BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_STAMINA]               = { Name = "STAMINA            "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_FLAT,       Mode = MODE_ADD,  BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_INTELLECT]             = { Name = "INTELLECT          "        , AffectOnStats = true,  AffectedStats = {[PSR_SPELL_POWER] = 1.0}, Type = TYPE_FLAT,       Mode = MODE_ADD,  BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_SPIRIT]                = { Name = "SPIRIT             "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_FLAT,       Mode = MODE_ADD,  BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_CRIT_DAMAGE_BONUS]     = { Name = "CRIT_DAMAGE_BONUS  "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_CRIT_HEALING_BONUS]    = { Name = "CRIT_HEALING_BONUS "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },    
        [PSR_DAMAGE_DONE_BONUS]     = { Name = "DAMAGE_DONE_BONUS  "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },    
        [PSR_DODGE]                 = { Name = "DODGE              "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_PARRY]                 = { Name = "PARRY              "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_HIT]                   = { Name = "HIT                "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_CRIT]                  = { Name = "CRIT               "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_MULTISTRIKE]           = { Name = "MULTISTRIKE        "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_READINESS]             = { Name = "READINESS          "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_SPEED]                 = { Name = "SPEED              "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_PVP_RESILIENCE]        = { Name = "PVP_RESILIENCE     "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_LEECH]                 = { Name = "LEECH              "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_HASTE]                 = { Name = "HASTE              "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_EXPERTISE]             = { Name = "EXPERTISE          "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_MASTERY]               = { Name = "MASTERY            "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_PVP_POWER]             = { Name = "PVP_POWER          "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_VERSATILITY]           = { Name = "VERSATILITY        "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_SPELL_POWER]           = { Name = "SPELL_POWER        "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_FLAT,       Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_ATTACK_POWER]          = { Name = "ATTACK_POWER       "        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_FLAT,       Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_ATTACK_POWER_RANGED]   = { Name = "ATTACK_POWER_RANGED"        , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_FLAT,       Mode = MODE_MULT, BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [PSR_ATTACK_SPEED]          = { Name = "ATTACK_SPEED"               , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_ADD,  BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [SSR_CAST_TIME_PERCENTAGE]  = { Name = "SSR_CAST_TIME_PERCENTAGE"   , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_PERCENTAGE, Mode = MODE_ADD,  BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} },
        [SSR_CAST_TIME_FLAT]        = { Name = "SSR_CAST_TIME_FLAT"         , AffectOnStats = false, AffectedStats = {},                        Type = TYPE_FLAT,       Mode = MODE_ADD,  BaseValue = 0, BaseValuePct = 0.0, BuffValue = 0, BuffValuePct = 1.0, BuffedValue = 0, BuffedValuePct = 0.0, BuffString = "", Buffs = {} }
    },
    Equipment = {
        
        EquipmentInfoUpdated = false,
        EquipmentInfoUpdatePending = false,
        
        Inventory = {
            [INVSLOT_AMMO] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_HEAD] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_NECK] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_SHOULDER] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_BODY] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_CHEST] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_WAIST] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_LEGS] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_FEET] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_WRIST] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_HAND] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_FINGER1] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_FINGER2] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_TRINKET1] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_TRINKET2] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_BACK] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_MAINHAND] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_OFFHAND] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_RANGED] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            },
            [INVSLOT_TABARD] = {
                SlotEquipped = false,
                ItemID = 0,
                ItemLevel = 0,
                ItemQuality = 0
            }
        }
    },
    GearSpecific = {
        MetagemCritEffect = 1.0,
        AmplificationEffect = 1.0,
        TierArmorSets = {
            [18] = {
                ArmorSetItems = { 124156, 124162, 124167, 124173, 124179 },
                EquippedTierItemsCount = 0,
                TierBonus2P = {
                    Active  = false,
                    SpellID = 185965,
                    SpellName = "",
                    SpellDuration = 3600,
                    SpellStacks = 1
                },
                TierBonus4P = {
                    Active  = false,
                    SpellID = 0,
                    SpellName = "",
                    SpellDuration = 0,
                    SpellStacks = 0
                }
            }
        }
    },
    
    GroupInfo = {
        GroupMember = {
            },
        GroupMembersNumber      = 1,
        DamagersOnPlayersTarget = 1.0,
        IsInRaid                = false,
        IsInGroup               = false
    },
    
    PlayerInfo = {
        PlayerLevel         = 0,
        PlayerSpec          = SPEC_NONE,
        PlayerReactionTime  = 0.1,
        PlayerMasteryMod    = 1.0,
        GetSpecBuffs        = nil,
        PlayerIsMoving      = false,
        PlayerIsJumping     = false,

        [CBDT.WARLOCK_AFFLICTION] = {
            SoulShards = 1,
            MasteryMod = 3.0999999046
        },
        [CBDT.WARLOCK_DEMONOLOGY] = {
            DemonicFury = 200,
            MasteryMod = 1.0
        },
        [CBDT.WARLOCK_DESTRUCTION] = {
            BurningEmberBits = 10,
            MasteryMod = 3.0,
            BaseMastery = 1.24,
            NonEmberBaseMastery = 1.09,
            UseEmberKillOnTrashTargets = false,
            Backdraft = {
                SpellID = 117828,
                UseBackdraftStacks = false,
            },
            BaneOfHavoc = {
                SpellID = 80240,
                Active = false,
                Stacks = 0,
                Remains = 0.0
            }
        }
    },
    
    DPEtSpells = {
        [DPET_CHAOS_BOLT_SPELL_ID] = {
            Name = "Стрела Хаоса",
            DamageStats = {
                [PSR_SPELL_POWER]           = { BaseValue = 2.38875,    BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_MASTERY]               = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_CRIT]                  = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_VERSATILITY]           = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_CRIT_DAMAGE_BONUS]     = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_DAMAGE_DONE_BONUS]     = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_HASTE]                 = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_MULTISTRIKE]           = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [SSR_CAST_TIME_PERCENTAGE]  = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [SSR_CAST_TIME_FLAT]        = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 }
            },
            DPET = {BuffSpellID = {}, BuffRemains = {}, Stage = {}, BaseValues = { Damage = 0.0, DPET = 0.0, CastTime = 0.0, CritDamage = 0.0, AverageDamage = 0.0, AverageDPET = 0.0 } }
        },
		[DPET_SHADOW_BURN_SPELL_ID] = {
            Name = "Ожог Тьмы",
            DamageStats = {
                [PSR_SPELL_POWER]           = { BaseValue = 3.57,       BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_MASTERY]               = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_CRIT]                  = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_VERSATILITY]           = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_CRIT_DAMAGE_BONUS]     = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_DAMAGE_DONE_BONUS]     = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_HASTE]                 = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_MULTISTRIKE]           = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [SSR_CAST_TIME_PERCENTAGE]  = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [SSR_CAST_TIME_FLAT]        = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 }
            },
            DPET = {BuffSpellID = {}, BuffRemains = {}, Stage = {}, BaseValues = { Damage = 0.0, DPET = 0.0, CastTime = 0.0, CritDamage = 0.0, AverageDamage = 0.0, AverageDPET = 0.0 } }
        },
        [DPET_INCINERATE_SPELL_ID] = {
            Name = "Испепеление",
            DamageStats = {
                [PSR_SPELL_POWER]           = { BaseValue = 1.50675,    BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_MASTERY]               = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_CRIT]                  = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_VERSATILITY]           = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_CRIT_DAMAGE_BONUS]     = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_DAMAGE_DONE_BONUS]     = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_HASTE]                 = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [PSR_MULTISTRIKE]           = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [SSR_CAST_TIME_PERCENTAGE]  = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 },
                [SSR_CAST_TIME_FLAT]        = { BaseValue = 1.0,        BuffValue = 0, BuffValuePct = 1.0 }
            },
            DPET = {BuffSpellID = {}, BuffRemains = {}, Stage = {}, BaseValues = { Damage = 0.0, DPET = 0.0, CastTime = 0.0, CritDamage = 0.0, AverageDamage = 0.0, AverageDPET = 0.0 } }
        }
    },
    Auras = {
        PlayerAuraIndex = 0,
        PlayerAura = {},
        SimulatedPlayerAuras = {}
    },
    Target = {
        TargetGUID = 0,
        TargetHealth = 0,
        TargetHealthMax = 0,
        TargetHealthPct = 0.0,
        TargetLevel = 0,
        TargetEmberKillThreshold = 0.0,
		TargetIsAttackable = false
    }
}

CBDT.SpellEffects = {
    [A_MOD_STAT] = {
        Name = "A_MOD_STAT",
        Type = TYPE_FLAT,
        IndexMode = INDEX_MODE_DIRECT,
        SelectIndex = 1,
        SubTypes = {
            [-2] = PSR_ALL_STATS,
            [-1] = PSR_ALL_STATS,
            [0] = PSR_STRENGTH,
            [1] = PSR_AGILITY,
            [2] = PSR_STAMINA,
            [3] = PSR_INTELLECT,
            [4] = PSR_SPIRIT
        }
    },
    [A_MOD_PERCENT_STAT] = {
        Name = "A_MOD_PERCENT_STAT",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_DIRECT,
        SelectIndex = 1,
        SubTypes = {
            [-2] = PSR_ALL_STATS,
            [-1] = PSR_ALL_STATS,
            [0] = PSR_STRENGTH,
            [1] = PSR_AGILITY,
            [2] = PSR_STAMINA,
            [3] = PSR_INTELLECT,
            [4] = PSR_SPIRIT
        }
    },        
    [A_MOD_CRITICAL_HEALING_AMOUNT] = {
        Name = "A_MOD_CRITICAL_HEALING_AMOUNT",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_CRIT_HEALING_BONUS
        }
    },
    [A_MOD_RATING] = {
        Name = "A_MOD_RATING",
        Type = TYPE_FLAT,
        IndexMode = INDEX_MODE_MASK,
        SelectIndex = 1,
        SubTypes = {
            [0x00000004] = PSR_DODGE,
            [0x00000008] = PSR_PARRY,
            [0x000000E0] = PSR_HIT,             --A_MOD_RATING_HIT_MELEE | A_MOD_RATING_HIT_RANGED | A_MOD_RATING_HIT_SPELL
            [0x00000700] = PSR_CRIT,            --A_MOD_RATING_CRIT_MELEE | A_MOD_RATING_CRIT_RANGED | A_MOD_RATING_CRIT_SPELL
            [0x00000800] = PSR_MULTISTRIKE,
            [0x00001000] = PSR_READINESS,
            [0x00002000] = PSR_SPEED,
            [0x00008000] = PSR_PVP_RESILIENCE,
            [0x00010000] = PSR_LEECH,
            [0x000E0000] = PSR_HASTE,           --A_MOD_RATING_HASTE_MELEE | A_MOD_RATING_HASTE_RANGED | A_MOD_RATING_HASTE_SPELL
            [0x00800000] = PSR_EXPERTISE,
            [0x02000000] = PSR_MASTERY,
            [0x04000000] = PSR_PVP_POWER,
            [0x70000000] = PSR_VERSATILITY     --A_MOD_RATING_VERSATILITY_DAMAGE | A_MOD_RATING_VERSATILITY_HEALING | A_MOD_RATING_VERSATILITY_MITIGATION
        }
    },
    [A_MOD_DAMAGE_PERCENT_DONE] = {
        Name = "A_MOD_DAMAGE_PERCENT_DONE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_MASK,
        SelectIndex = 1,
        SubTypes = {
            [0x01] = PSR_DAMAGE_DONE_BONUS, --A_MOD_DAMAGE_PERCENT_DONE_PHYSICAL
            [0x02] = PSR_DAMAGE_DONE_BONUS, --A_MOD_DAMAGE_PERCENT_DONE_HOLY
            [0x04] = PSR_DAMAGE_DONE_BONUS, --A_MOD_DAMAGE_PERCENT_DONE_FIRE
            [0x08] = PSR_DAMAGE_DONE_BONUS, --A_MOD_DAMAGE_PERCENT_DONE_NATURE
            [0x10] = PSR_DAMAGE_DONE_BONUS, --A_MOD_DAMAGE_PERCENT_DONE_FROST
            [0x20] = PSR_DAMAGE_DONE_BONUS, --A_MOD_DAMAGE_PERCENT_DONE_SHADOW
            [0x40] = PSR_DAMAGE_DONE_BONUS  --A_MOD_DAMAGE_PERCENT_DONE_ARCANE
        }
    },
    [A_MOD_CRIT_DAMAGE_BONUS] = {
        Name = "A_MOD_CRIT_DAMAGE_BONUS",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_DIRECT,
        SelectIndex = 1,
        SubTypes = {
            [127] = PSR_CRIT_DAMAGE_BONUS,
            [895] = PSR_CRIT_DAMAGE_BONUS
        }
    },
    [A_MOD_TOTAL_STAT_PERCENTAGE] = {
        Name = "A_MOD_TOTAL_STAT_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_MASK,
        SelectIndex = 2,
        SubTypes = {
            [0x01] = PSR_STRENGTH,
            [0x02] = PSR_AGILITY,
            [0x04] = PSR_STAMINA,
            [0x08] = PSR_INTELLECT,
            [0x10] = PSR_SPIRIT
        }
        
    },
    [A_MOD_HASTE] = {
        Name = "A_MOD_HASTE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_DIRECT,
        SelectIndex = 1,
        SubTypes = {
            [0]   = PSR_HASTE,
            [126] = PSR_HASTE,
            [10]  = PSR_HASTE,
            [14]  = PSR_HASTE,
            [15]  = PSR_HASTE
            
        }
    },
    [A_MOD_SPELL_POWER_PERCENTAGE] = {
        Name = "A_MOD_SPELL_POWER_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_SPELL_POWER
        }
    },
    [A_MOD_RATING_PERCENTAGE] = {
        Name = "A_MOD_RATING_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_MASK,
        SelectIndex = 1,
        SubTypes = {
            [0x00000004] = PSR_DODGE,
            [0x00000008] = PSR_PARRY,
            [0x000000E0] = PSR_HIT,             --A_MOD_RATING_HIT_MELEE | A_MOD_RATING_HIT_RANGED | A_MOD_RATING_HIT_SPELL
            [0x00000700] = PSR_CRIT,            --A_MOD_RATING_CRIT_MELEE | A_MOD_RATING_CRIT_RANGED | A_MOD_RATING_CRIT_SPELL
            [0x00000800] = PSR_MULTISTRIKE,
            [0x00001000] = PSR_READINESS,
            [0x00002000] = PSR_SPEED,
            [0x00008000] = PSR_PVP_RESILIENCE,
            [0x00010000] = PSR_LEECH,
            [0x000E0000] = PSR_HASTE,           --A_MOD_RATING_HASTE_MELEE | A_MOD_RATING_HASTE_RANGED | A_MOD_RATING_HASTE_SPELL
            [0x00800000] = PSR_EXPERTISE,
            [0x02000000] = PSR_MASTERY,
            [0x04000000] = PSR_PVP_POWER,
            [0x70000000] = PSR_VERSATILITY     --A_MOD_RATING_VERSATILITY_DAMAGE | A_MOD_RATING_VERSATILITY_HEALING | A_MOD_RATING_VERSATILITY_MITIGATION
        }
    },
    [A_MOD_MULTISTRIKE_PERCENTAGE] = {
        Name = "A_MOD_MULTISTRIKE_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_MULTISTRIKE
        }
    },
    [A_MOD_ATTACK_POWER_PERCENTAGE] = {
        Name = "A_MOD_ATTACK_POWER_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_ATTACK_POWER
        }
    },
    [A_MOD_RANGED_ATTACK_POWER_PERCENTAGE] = {
        Name = "A_MOD_RANGED_ATTACK_POWER_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_ATTACK_POWER_RANGED
        }
    },
    [A_MOD_ALL_CRIT_PERCENTAGE] = {
        Name = "A_MOD_ALL_CRIT_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_CRIT
        }
    },
    [A_MOD_VERSATILITY_PERCENTAGE] = {
        Name = "A_MOD_VERSATILITY_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_VERSATILITY
        }
    },
    [A_MOD_ALL_MASTERY_PERCENTAGE] = {
        Name = "A_MOD_ALL_MASTERY_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_MASTERY
        }
    },
    [A_MOD_SPELL_POWER] = {
        Name = "A_MOD_SPELL_POWER",
        Type = TYPE_FLAT,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_SPELL_POWER
        }
    },
    [A_MOD_RANGED_ATTACK_POWER] = {
        Name = "A_MOD_RANGED_ATTACK_POWER",
        Type = TYPE_FLAT,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_ATTACK_POWER_RANGED
        }
    },
    [A_MOD_ATTACK_POWER] = {
        Name = "A_MOD_ATTACK_POWER",
        Type = TYPE_FLAT,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_ATTACK_POWER
        }
    },
    [A_MOD_SPELL_CRIT_CHANCE] = {
        Name = "A_MOD_SPELL_CRIT_CHANCE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_CRIT
        }
    },
    [A_MOD_ATTACK_SPEED_PERCENTAGE] = {
        Name = "A_MOD_ATTACK_SPEED_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_ATTACK_SPEED
        }
    },
    [A_MOD_CASTING_SPEED_NOT_STACK] = {
        Name = "A_MOD_CASTING_SPEED_NOT_STACK",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_MASK,
        SelectIndex = 1,
        SubTypes = {
            [0x000E0000] = PSR_HASTE           --A_MOD_RATING_HASTE_MELEE | A_MOD_RATING_HASTE_RANGED | A_MOD_RATING_HASTE_SPELL
        }
    },
    [A_ADD_PERCENTAGE_MODIFIER] = {
        Name = "A_ADD_PERCENTAGE_MODIFIER",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_DIRECT,
        SelectIndex = 1,
        SubTypes = {
            [0]     = PSR_DAMAGE_DONE_BONUS,
            [10]    = SSR_CAST_TIME_PERCENTAGE
        }
    },
    [A_ADD_FLAT_MODIFIER] = {
        Name = "A_ADD_FLAT_MODIFIER",
        Type = TYPE_FLAT,
        IndexMode = INDEX_MODE_DIRECT,
        SelectIndex = 1,
        SubTypes = {
            [0]     = PSR_DAMAGE_DONE_BONUS
            --[10]    = SSR_CAST_TIME_FLAT --Деактивировано, обычно перманентный бонус, не будем плодить лишние DPET-уровни, к тому же пока не обрабатывается
        }
    },
    [A_MOD_SPELL_CRITICAL_STRIKE_PERCENTAGE] = {
        Name = "A_MOD_SPELL_CRITICAL_STRIKE_PERCENTAGE",
        Type = TYPE_PERCENTAGE,
        IndexMode = INDEX_MODE_ANY,
        SelectIndex = 1,
        SubTypes = {
            ["ANY"] = PSR_CRIT
        }
    }
    
}

CBDT.StageDisplay = {
    
    InitDone = false,
    
    Stages = {
        Max     = 5,
        Min     = 1,
        Current = 5
    },
    TimeWindow = {
        Max     = 40,
        Min     = 5,
        Current = 20
    },
    StageBarWidth = {
        Max     = 1920,
        Min     = 50,
        Current = 200
    },
    StageBarHeight = {
        Max     = 64,
        Min     = 16,
        Current = 32
    },
    StageBarOffsetX = {
        Max     =  960,
        Min     = -960,
        Current = 0
    },
    StageBarOffsetY = {
        Max     = 540,
        Min     = -540, 
        Current = -140
    },
    StageDescriptionFontSize = {
        Max                 = 24,
        Min                 = 8,
        Current             = 10,
        TextBoxFullHeight   = 12,
        TextBoxHalfHeight   = 6
    },
    DPEtLowThresholdPct = {
        Max     = 10.0,
        Min     = 1.0,
        Current = 1.0
    },
    DPEtHighThresholdPct = {
        Max     = 10.0,
        Min     = 1.0,
        Current = 1.50
    },
    PrimarySpellIcon = {
        Active          = true,
        Icon            = {},
        IconSelector    = DPET_CHAOS_BOLT_SPELL_ID,
        IconData = {
            [DPET_CHAOS_BOLT_SPELL_ID] = {},
            [DPET_SHADOW_BURN_SPELL_ID] = {}
        }
    },
    DPEtSpellCastLine = {
        Active          = true,
        Cl              = {},
        ActiveColor     = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 },
        InactiveColor   = { r = 1.0, g = 1.0, b = 1.0, a = 0.3 },
        CurrentColor    = COLOR_NOT_SET,
        SelectedColor   = COLOR_NOT_SET
    },
    StageBarBg = {
        Bg              = {},
        ActiveColor     = { r = 0.0, g = 0.0, b = 0.0, a = 0.5 },
        InactiveColor   = { r = 0.0, g = 0.0, b = 0.0, a = 0.1 },
        CurrentColor    = COLOR_NOT_SET,
        SelectedColor   = COLOR_NOT_SET
    },
    StageBars = {
        [1] = {
            Active          = false,
            TimeRemains     = 0.0,
            ActiveColor     = { r = 0.77, g = 0.12, b = 0.23, a = 1.0 },
            InactiveColor   = { r = 0.77, g = 0.12, b = 0.23, a = 0.3 },
            CurrentColor    = COLOR_NOT_SET,
            SelectedColor   = COLOR_NOT_SET,
            StageBar        = {},
            Description     = {
                Text            = {},
                Active          = true,
                ActiveColor     = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 },
                InactiveColor   = { r = 1.0, g = 1.0, b = 1.0, a = 0.3 },
                CurrentColor    = COLOR_NOT_SET,
                SelectedColor   = COLOR_NOT_SET
            }
        },
        [2] = {
            Active          = false,
            TimeRemains     = 0.0,
            ActiveColor     = { r = 1.0, g = 0.49, b = 0.04, a = 1.0 },
            InactiveColor   = { r = 1.0, g = 0.49, b = 0.04, a = 0.3 },
            CurrentColor    = COLOR_NOT_SET,
            SelectedColor   = COLOR_NOT_SET,
            StageBar        = {},
            Description     = {
                Text            = {},
                Active          = true,
                ActiveColor     = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 },
                InactiveColor   = { r = 1.0, g = 1.0, b = 1.0, a = 0.3 },
                CurrentColor    = COLOR_NOT_SET,
                SelectedColor   = COLOR_NOT_SET
            }
        },
        [3] = {
            Active          = false,
            TimeRemains     = 0.0,
            ActiveColor     = { r = 1.0, g = 0.96, b = 0.41, a = 1.0 },
            InactiveColor   = { r = 1.0, g = 0.96, b = 0.41, a = 0.3 },
            CurrentColor    = COLOR_NOT_SET,
            SelectedColor   = COLOR_NOT_SET,
            StageBar        = {},
            Description     = {
                Text            = {},
                Active          = false,
                ActiveColor     = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 },
                InactiveColor   = { r = 1.0, g = 1.0, b = 1.0, a = 0.3 },
                CurrentColor    = COLOR_NOT_SET,
                SelectedColor   = COLOR_NOT_SET
            }
        },
        [4] = {
            Active          = false,
            TimeRemains     = 0.0,
            ActiveColor     = { r = 0.67, g = 0.83, b = 0.45, a = 1.0 },
            InactiveColor   = { r = 0.67, g = 0.83, b = 0.45, a = 0.3 },
            CurrentColor    = COLOR_NOT_SET,
            SelectedColor   = COLOR_NOT_SET,
            StageBar        = {},
            Description     = {
                Text            = {},
                Active          = false,
                ActiveColor     = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 },
                InactiveColor   = { r = 1.0, g = 1.0, b = 1.0, a = 0.3 },
                CurrentColor    = COLOR_NOT_SET,
                SelectedColor   = COLOR_NOT_SET
            }
        },
        [5] = {
            Active          = false,
            TimeRemains     = 0.0,
            ActiveColor     = { r = 0.41, g = 0.80, b = 0.94, a = 1.0 },
            InactiveColor   = { r = 0.41, g = 0.80, b = 0.94, a = 0.3 },
            CurrentColor    = COLOR_NOT_SET,
            SelectedColor   = COLOR_NOT_SET,
            StageBar        = {},
            Description     = {
                Text            = {},
                Active          = false,
                ActiveColor     = { r = 1.0, g = 1.0, b = 1.0, a = 1.0 },
                InactiveColor   = { r = 1.0, g = 1.0, b = 1.0, a = 0.3 },
                CurrentColor    = COLOR_NOT_SET,
                SelectedColor   = COLOR_NOT_SET
            }
        }
    }
}

CBDT.SoundNotification = {
    SelectedChaosBoltSoundIndex     = 1,
    SelectedShadowburnSoundIndex    = 1,
    SelectedSoundChannel            = 1,
    Replay = {
        Pending             = false,
        CurrentEventSource  = NSR_NO_SOURCE,
        LastEventSource     = NSR_NO_SOURCE
    },
    Sounds = {
        [1] = { SoundName = "No Sound", SoundPath = "" },
        [2] = { SoundName = "Electric Spark", SoundPath = "Interface\\AddOns\\Chaos Bolt DPET Tracker\\Sounds\\Electric Spark.ogg" },
        [3] = { SoundName = "Quad Damage", SoundPath = "Interface\\AddOns\\Chaos Bolt DPET Tracker\\Sounds\\Quad Damage.ogg" },
        [4] = { SoundName = "Robot Blip", SoundPath = "Interface\\AddOns\\Chaos Bolt DPET Tracker\\Sounds\\Robot Blip.ogg" },
        [5] = { SoundName = "Sonar", SoundPath = "Interface\\AddOns\\Chaos Bolt DPET Tracker\\Sounds\\Sonar.ogg" },
        [6] = { SoundName = "Tick", SoundPath = "Interface\\AddOns\\Chaos Bolt DPET Tracker\\Sounds\\Tick.ogg" }
    },
    Channels = {
        [1] = "SFX",
        [2] = "Music",
        [3] = "Ambience",
        [4] = "Master"
    }
}

CBDT.CritMetaGems = {
    [32409] = 44797, -- Relentless Earthstorm Diamond
    [34220] = 44797, -- Chaotic Skyfire Diamond
    [41285] = 44797, -- Chaotic Skyflare Diamond
    [41376] = 44797, -- Revitalizing Skyflare Diamond
    [41398] = 44797, -- Relentless Earthsiege Diamond
    [52291] = 44797, -- Chaotic Shadowspirit Diamond
    [52297] = 44797, -- Revitalizing Shadowspirit Diamond
    [68778] = 44797, -- Agile Shadowspirit Diamond
    [68779] = 44797, -- Reverberating Shadowspirit Diamond
    [68780] = 44797, -- Burning Shadowspirit Diamond
    [76884] = 44797, -- Agile Primal Diamond
    [76885] = 44797, -- Burning Primal Diamond
    [76886] = 44797, -- Reverberating Primal Diamond
    [76888] = 44797, -- Revitalizing Primal Diamond
}

CBDT.AmplificationTrinkets = {
	[102293] = 146051, -- Purified Bindings of Immerseus
	[104426] = 146051, -- Purified Bindings of Immerseus (Heroic)
	[104675] = 146051, -- Purified Bindings of Immerseus (Flexible)
	[104924] = 146051, -- Purified Bindings of Immerseus (Raid Finder)
	[105173] = 146051, -- Purified Bindings of Immerseus (Warforged)
	[105422] = 146051, -- Purified Bindings of Immerseus (Heroic Warforged)

	[102299] = 146051, -- Prismatic Prison of Pride
	[104478] = 146051, -- Prismatic Prison of Pride (Heroic)
	[104727] = 146051, -- Prismatic Prison of Pride (Flexible)
	[104976] = 146051, -- Prismatic Prison of Pride (Raid Finder)
	[105225] = 146051, -- Prismatic Prison of Pride (Warforged)
	[105474] = 146051, -- Prismatic Prison of Pride (Heroic Warforged)

	[102305] = 146051, -- Thok's Tail Tip
	[104613] = 146051, -- Thok's Tail Tip (Heroic)
	[104862] = 146051, -- Thok's Tail Tip (Flexible)
	[105111] = 146051, -- Thok's Tail Tip (Raid Finder)
	[105360] = 146051, -- Thok's Tail Tip (Warforged)
	[105609] = 146051, -- Thok's Tail Tip (Heroic Warforged)
}

function CBDT.Player:GetEquipmentInfo()
    
    local ItemLink = {}
    
    for EquipmentSlotID, EquipmentSlot in pairs ( CBDT.Player.Equipment.Inventory ) do
        
        if CBDT.IsDebugEnabled then
            if EquipmentSlotID == INVSLOT_TRINKET1 then
                ItemLink = "|cffa335ee|Hitem:124522:0:0:0:0:0:0:0:20:267:0:6:1:566|h[Фрагмент Темной звезды]|h|r"
            elseif EquipmentSlotID == INVSLOT_FINGER1 then
                ItemLink = "|cffff8000|Hitem:124635:0:0:0:0:0:0:0:20:267:0:0:1:641|h[Нитрам, Провидец]|h|r"
            elseif EquipmentSlotID == INVSLOT_OFFHAND then
                ItemLink = "|cff0070dd|Hitem:110043:0:0:0:0:0:0:0:20:267:0:17:1:518|h[Бабушка Гуг'рокка]|h|r"
            else
                ItemLink = GetInventoryItemLink( "player", EquipmentSlotID )
            end
        else
            ItemLink = GetInventoryItemLink( "player", EquipmentSlotID )
        end

        if ( ItemLink ~= nil ) then
            
            if CBDT.IsDebugEnabled then
                EquipmentSlot.ItemID = tonumber( (string.gsub(string.match(ItemLink, "Hitem:%d+"),"Hitem:","")) )
            else
                EquipmentSlot.ItemID = GetInventoryItemID( "player", EquipmentSlotID )
            end
            EquipmentSlot.ItemQuality, EquipmentSlot.ItemLevel  = select ( 3, GetItemInfo( ItemLink ) )
            
            --Информации по данному предмету нет в памяти и она будет загружена клиентом позже, пока ставим флаги и выходим
            if EquipmentSlot.ItemLevel == nil or EquipmentSlot.ItemQuality == nil then
                CBDT.Player.Equipment.EquipmentInfoUpdated       = false
                CBDT.Player.Equipment.EquipmentInfoUpdatePending = true
                return
            end
           
            if CBDT.IsDebugEnabled then
                print(EquipmentSlotID, ItemLink, EquipmentSlot.ItemLevel, EquipmentSlot.ItemQuality, EquipmentSlot.ItemID)
            end
            
            EquipmentSlot.SlotEquipped = true
            
        else
            
            EquipmentSlot.SlotEquipped = false
            EquipmentSlot.ItemID      = 0
            EquipmentSlot.ItemQuality = 0
            EquipmentSlot.ItemLevel   = 0
        end
    end
    
    CBDT.Player.Equipment.EquipmentInfoUpdated = true
    CBDT.Player.Equipment.EquipmentInfoUpdatePending = false
    
end

function CBDT.Player:GetTierBonuses()
    
    if not CBDT.Player.Equipment.EquipmentInfoUpdated then
        return
    end
    
    --Сбрасываем количество вещей комплекта брони
    for _, Tier in pairs ( CBDT.Player.GearSpecific.TierArmorSets ) do
        Tier.EquippedTierItemsCount = 0
    end
    
    --Обновляем количество экипированных вещей для всех комплектов брони
    for _, EquipmentSlot in pairs ( CBDT.Player.Equipment.Inventory ) do
       
        if EquipmentSlot.SlotEquipped then
            
            for _, Tier in pairs ( CBDT.Player.GearSpecific.TierArmorSets ) do
          
                for _, TierItemID in pairs (Tier.ArmorSetItems) do
                    
                    if TierItemID == EquipmentSlot.ItemID then
                        
                        Tier.EquippedTierItemsCount = Tier.EquippedTierItemsCount + 1
                        break
                    end
                end
            end
        end
    end
    
    --Обновляем флаги бонусов 2-х и 4-х частей брони
    for TierNumber, Tier in pairs ( CBDT.Player.GearSpecific.TierArmorSets ) do
        if Tier.EquippedTierItemsCount > 3 then
            
            if Tier.TierBonus4P.SpellID ~= 0 then
                Tier.TierBonus4P.Active     = true
                Tier.TierBonus4P.SpellName  = GetSpellInfo(Tier.TierBonus4P.SpellID)
            end
            
            if Tier.TierBonus2P.SpellID ~= 0 then
                Tier.TierBonus2P.Active     = true
                Tier.TierBonus2P.SpellName  = GetSpellInfo(Tier.TierBonus2P.SpellID)
            end
            
        elseif Tier.EquippedTierItemsCount > 1 then
            
            Tier.TierBonus4P.Active = false
            
            if Tier.TierBonus2P.SpellID ~= 0 then
                Tier.TierBonus2P.Active     = true
                Tier.TierBonus2P.SpellName  = GetSpellInfo(Tier.TierBonus2P.SpellID)
            end

        else
            
            Tier.TierBonus4P.Active = false
            Tier.TierBonus2P.Active = false
            
        end
        
        if CBDT.IsDebugEnabled then
            if Tier.TierBonus4P.Active then
                print("Tier " .. TierNumber .. " 4P bonus active")
            elseif Tier.TierBonus2P.Active then
                print("Tier " .. TierNumber .. " 2P bonus active")
            end
        end
    end
end

function CBDT.Player.PlayerInfo.GetSpecBuffs()
    
    if CBDT.Player.PlayerInfo[CBDT.Player.PlayerInfo.PlayerSpec] then
        if CBDT.Player.PlayerInfo.PlayerSpec == CBDT.WARLOCK_DESTRUCTION then
    
            --Новый цикл проверки баффов? Если да, то сбрасываем флаги активности баффов специализации
            if CBDT.Player.Auras.PlayerAuraIndex == 1 then
                
                --Сбрасываем флаг активности и стаки "Хаос"
                CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.Active  = false
                CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.Remains = 0.0
                CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.Stacks  = 0
            end
            
            --Обработка "Хаос"
            if CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID] == CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.SpellID then
                
                CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.Stacks  = CBDT.Player.Auras.PlayerAura[UNIT_AURA_STACKS]
                CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.Remains = CBDT.Player.Auras.PlayerAura[UNIT_AURA_EXPIRES] - GetTime()
                CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.Active  = true
            end
        end
    end
end

function CBDT.Player:GetGroupInfo()
    
    local GroupMemberID = ""
    
    for _, GroupMember in pairs( CBDT.Player.GroupInfo.GroupMember ) do
        GroupMember.Active      = false
        GroupMember.Role        = "NONE"
        GroupMember.TargetGUID  = 0
    end
    
    CBDT.Player.GroupInfo.GroupMembersNumber = GetNumGroupMembers()
    
    if CBDT.Player.GroupInfo.IsInRaid then
        for i = 1, CBDT.Player.GroupInfo.GroupMembersNumber do
            
            GroupMemberID = "raid"..i
            
            if CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ] then
                if not CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].Active then
                    CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].Active     = true
                    CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].Role       = UnitGroupRolesAssigned( GroupMemberID )
                    CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].TargetGUID = UnitGUID( GroupMemberID.."target" ) or 0
                end
            else
                CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ] = {
                    Active      = true,
                    Role        = UnitGroupRolesAssigned( GroupMemberID ),
                    TargetGUID  = UnitGUID( GroupMemberID.."target" ) or 0
                }
            end
        end
    elseif CBDT.Player.GroupInfo.IsInGroup then
        for i = 1, CBDT.Player.GroupInfo.GroupMembersNumber - 1 do
            
            GroupMemberID = "party"..i
            
            if CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ] then
                if not CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].Active then
                    CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].Active     = true
                    CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].Role       = UnitGroupRolesAssigned( GroupMemberID )
                    CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].TargetGUID = UnitGUID( GroupMemberID.."target" ) or 0
                end
            else
                CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ] = {
                    Active      = true,
                    Role        = UnitGroupRolesAssigned( GroupMemberID ),
                    TargetGUID  = UnitGUID( GroupMemberID.."target" ) or 0
                }
            end
        end
    end
end

function CBDT.Player:UpdateGroupTargetInfo( GroupMemberID )
    if CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ] then
        
        if not CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].Active then
            
            CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].Active     = true
            CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].Role       = UnitGroupRolesAssigned( GroupMemberID )

        end
        
        CBDT.Player.GroupInfo.GroupMember[ GroupMemberID ].TargetGUID = UnitGUID( GroupMemberID.."target" ) or 0
        
        CBDT.Player.GroupInfo.DamagersOnPlayersTarget = 1.0
        
        for _, GroupMember in pairs( CBDT.Player.GroupInfo.GroupMember ) do
            
            if GroupMember.Active and GroupMember.TargetGUID ~= 0 and GroupMember.TargetGUID == CBDT.Player.Target.TargetGUID then
                
                if GroupMember.Role == "TANK" then
                    
                    CBDT.Player.GroupInfo.DamagersOnPlayersTarget = CBDT.Player.GroupInfo.DamagersOnPlayersTarget + 0.6
                
                elseif GroupMember.Role == "DAMAGER" then
                    
                    CBDT.Player.GroupInfo.DamagersOnPlayersTarget = CBDT.Player.GroupInfo.DamagersOnPlayersTarget + 1.0
                
                end
            end
        end

        --В рейде игрок входит в общее количество участников, по этому корректируем, так как начальное значение бойцов на цели равно 1.0
        if CBDT.Player.GroupInfo.IsInRaid and CBDT.Player.GroupInfo.DamagersOnPlayersTarget >= 2.0 then
            CBDT.Player.GroupInfo.DamagersOnPlayersTarget = CBDT.Player.GroupInfo.DamagersOnPlayersTarget - 1.0
        end
        
    end
end

function CBDT.Player:GetMetagemCritEffect()
    
    local GemID = GetInventoryItemGems(INVSLOT_HEAD)
    
    if GemID then
        if CBDT.CritMetaGems[GemID] then
            CBDT.Player.GearSpecific.MetagemCritEffect = 1.03
        else
            CBDT.Player.GearSpecific.MetagemCritEffect = 1.00
        end
    else
        CBDT.Player.GearSpecific.MetagemCritEffect = 1.00
    end
end

function CBDT.Player:GetAmplificationEffect()
    
    local ItemID = 0
    local AmplificationEffect = 1.0
    
    for Slot = INVSLOT_TRINKET1, INVSLOT_TRINKET2 do
        ItemID = GetInventoryItemID("player", Slot)
        
        if ItemID and CBDT.AmplificationTrinkets[ItemID] then
            AmplificationEffect = AmplificationEffect * ( 1.0 + ( ( 1.15 ^ ( ( ( select( 4, GetItemInfo( ItemID ) ) ) - 553 ) / 15 ) ) * 0.07 ) )
        end
    end
    
    CBDT.Player.GearSpecific.AmplificationEffect = AmplificationEffect
end

function CBDT.StageDisplay:GetPrimarySpell()

    local PrimarySpell = DPET_NO_SPELL_ID
    local PrimarySpellAverageDamage = 0.0
    local ExecutePhase = false
    local Description = ""
    local DPET_LEVEL = DPET_NO_LEVEL
    local DPET_HI_LEVEL_MAX_STAGE_INDEX = 0
    local DPET_LOW_LEVEL_MAX_STAGE_INDEX = 0
    
    if CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BurningEmberBits < 10 then
        return PrimarySpell, "NOT_ENOUGH_EMBERS"
    end
    
    if not CBDT.Player.Target.TargetIsAttackable then
		return PrimarySpell, "TARGET_IS_NOT_ATTACKABLE"
	end

	if CBDT.Player.Target.TargetHealth == 0 then
		return PrimarySpell, "TARGET_HEALTH_IS_ZERO"
	end
    
    for Index, Stage in pairs( CBDT.Player.DPEtSpells[DPET_CHAOS_BOLT_SPELL_ID].DPET.Stage ) do
        if ( Stage.Active and Stage.DPEtPct >= CBDT.StageDisplay.DPEtLowThresholdPct.Current ) then
            if  ( Stage.DPEtPct >= CBDT.StageDisplay.DPEtHighThresholdPct.Current ) then
                DPET_LEVEL = DPET_HIGH_LEVEL
                DPET_HI_LEVEL_MAX_STAGE_INDEX = Index
            else
                if DPET_LEVEL ~= DPET_HIGH_LEVEL then
                    DPET_LEVEL = DPET_LOW_LEVEL
                end
                DPET_LOW_LEVEL_MAX_STAGE_INDEX = Index
            end
        end
    end
    
    --Проверяем текущее здоровье цели и устанавливаем флаг экзекьют фазы
    if CBDT.Player.Target.TargetHealthPct <= 20 then
        ExecutePhase = true
    end

    --Определяем приоритетное заклинание исходя из текущего уровня здоровья цели и среднего прогнозируемого урона
    --Проверяем находится ли текущий уровень DPET выше установленной игроком верхней границы
    if DPET_LEVEL == DPET_HIGH_LEVEL then
        
        for Index = 1, DPET_HI_LEVEL_MAX_STAGE_INDEX do
            if CBDT.Player.DPEtSpells[DPET_CHAOS_BOLT_SPELL_ID].DPET.Stage[Index].StageRemains > ( CBDT.Player.DPEtSpells[DPET_CHAOS_BOLT_SPELL_ID].DPET.Stage[Index].CastTime + CBDT.Player.PlayerInfo.PlayerReactionTime ) then
                --Если средний DPET "Стрелы Хаоса" больше среднего DPET "Ожога Тьмы"
                if CBDT.Player.DPEtSpells[DPET_CHAOS_BOLT_SPELL_ID].DPET.Stage[Index].AverageDPET > CBDT.Player.DPEtSpells[DPET_SHADOW_BURN_SPELL_ID].DPET.Stage[Index].AverageDPET then
                    PrimarySpell = DPET_CHAOS_BOLT_SPELL_ID
                    Description = "CHAOS_BOLT_DPET_IS_HIGHER"
                    DPET_HI_LEVEL_MAX_STAGE_INDEX = Index
                    break
                --Можно ли использовать "Ожог Тьмы"
                elseif ExecutePhase then
                    PrimarySpell = DPET_SHADOW_BURN_SPELL_ID
                    Description = "SHADOW_BURN_DPET_IS_HIGHER"
                    DPET_HI_LEVEL_MAX_STAGE_INDEX = Index
                    break
                else
                    --DPET "Стрела Хаоса" на всех уровнях оказался меньше чем "Ожог Тьмя", но не экзекут фаза, так что используем "Стрела Хаоса"
                    PrimarySpell = DPET_CHAOS_BOLT_SPELL_ID
                    Description = "CHAOS_BOLT_DPET_IS_LOWER_BUT_NOT_EXECUTE_PHASE"
                    DPET_HI_LEVEL_MAX_STAGE_INDEX = Index
                end
            elseif CBDT.Player.DPEtSpells[DPET_SHADOW_BURN_SPELL_ID].DPET.Stage[Index].StageRemains > CBDT.Player.PlayerInfo.PlayerReactionTime then
                --Можно ли использовать "Ожог Тьмы"
                if ExecutePhase then
                    PrimarySpell = DPET_SHADOW_BURN_SPELL_ID
                    Description = "SHADOW_BURN_DPET_IS_HIGHER"
                    DPET_HI_LEVEL_MAX_STAGE_INDEX = Index
                    break
                end
            end
        end
    else
        PrimarySpell = DPET_NO_SPELL_ID
        Description = "NO_HIGH_LEVEL_DPET_BUFFS"
        DPET_HI_LEVEL_MAX_STAGE_INDEX = 1
    end
   
    --Проверяем время каста "Испепеления", если у этого заклинания время каста меньше ГКД, то принудительный каст "Стрела Хаоса"
    if PrimarySpell == DPET_NO_SPELL_ID and CBDT.Player.DPEtSpells[DPET_INCINERATE_SPELL_ID].DPET.Stage[1].GCDCap then
        PrimarySpell = DPET_CHAOS_BOLT_SPELL_ID
        Description = "INCINERATE_CGD_CAPPED"
    end
    
    --На данном этапе если у нас выбрано заклинание, то оно с наивысшим DPET, для его каста достаточно времени и его можно применить
    if PrimarySpell ~= DPET_NO_SPELL_ID then
        return PrimarySpell, Description
    end
    
    --Проверка количества стаков "Хаос" и оставшегося времени
    if CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.Active then
        if CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.Stacks > 2 then
            if CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaneOfHavoc.Remains > ( CBDT.Player.DPEtSpells[DPET_CHAOS_BOLT_SPELL_ID].DPET.Stage[DPET_HI_LEVEL_MAX_STAGE_INDEX].CastTime + CBDT.Player.PlayerInfo.PlayerReactionTime ) then
                
                PrimarySpell = DPET_CHAOS_BOLT_SPELL_ID
                Description = "CHAOS_STACKS > 2"
                return PrimarySpell, Description
            elseif ExecutePhase then
                
                PrimarySpell = DPET_SHADOW_BURN_SPELL_ID
                Description = "CHAOS_STACKS > 2 BUT_NOT_ENOUGH_TIME_TO_CAST_CHAOS_BOLT"
                return PrimarySpell, Description
            end
        elseif ExecutePhase then
            
            PrimarySpell = DPET_SHADOW_BURN_SPELL_ID
            Description = "CHAOS_STACKS =< 2 EXECUTE_PHASE"
            return PrimarySpell, Description
        end
    end
    
    --Если угольков 29 или больше и текущий уровень DPET выше установленного игроком минимального, то можно слить один уголь
    if ( CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BurningEmberBits >= 29 ) and ( DPET_LEVEL == DPET_LOW_LEVEL ) then
        if ExecutePhase then
            PrimarySpell = DPET_SHADOW_BURN_SPELL_ID
            Description = "DPET_LOW_LEVEL_BUFFS_EMBER_CAP"
        else
            PrimarySpell = DPET_CHAOS_BOLT_SPELL_ID
            Description = "DPET_LOW_LEVEL_BUFFS_EMBER_CAP"
        end
    end
    
    --Если угольков 35 или больше и текущий уровень DPET не выше установленного игроком минимального, то можно слить один уголь
    if ( CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BurningEmberBits >= 35 ) and ( DPET_LEVEL == DPET_NO_LEVEL ) then
        if ExecutePhase then
            PrimarySpell = DPET_SHADOW_BURN_SPELL_ID
            Description = "DPET_NO_BUFFS_EMBER_CAP"
        else
            PrimarySpell = DPET_CHAOS_BOLT_SPELL_ID
            Description = "DPET_NO_BUFFS_EMBER_CAP"
        end
    end
    
    --Получаем средний прогнозируемый урон приоритетного заклинания
    if PrimarySpell == DPET_CHAOS_BOLT_SPELL_ID then
        PrimarySpellAverageDamage = CBDT.Player.DPEtSpells[DPET_CHAOS_BOLT_SPELL_ID].DPET.Stage[DPET_HI_LEVEL_MAX_STAGE_INDEX].AverageDamage
    elseif PrimarySpell == DPET_SHADOW_BURN_SPELL_ID or ExecutePhase then
        PrimarySpellAverageDamage = CBDT.Player.DPEtSpells[DPET_SHADOW_BURN_SPELL_ID].DPET.Stage[DPET_HI_LEVEL_MAX_STAGE_INDEX].AverageDamage
    else
        --Если приоритетное заклинание не выбрано и нет экзекьют фазы, то выбираем "Стрела Хаоса"
        PrimarySpellAverageDamage = CBDT.Player.DPEtSpells[DPET_CHAOS_BOLT_SPELL_ID].DPET.Stage[DPET_HI_LEVEL_MAX_STAGE_INDEX].AverageDamage
    end
    
    --Сможем ли мы снести цель за имеющееся количество раскаленных углей? В случае рейда или группы учитывается количество игроков с такой же целью как у нас.
    --Фактически необходимо для оценки возможности быстрого слива цели или слива углей до смерти цели.
    CBDT.Player.Target.TargetEmberKillThreshold = ( CBDT.Player.Target.TargetHealth / ( PrimarySpellAverageDamage * ( math.floor( CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BurningEmberBits * 0.1 ) ) * CBDT.Player.GroupInfo.DamagersOnPlayersTarget ) )
    if ( CBDT.Player.Target.TargetEmberKillThreshold < 1.1 ) then
        if ( ( ( PrimarySpellAverageDamage * 4 ) < CBDT.Player.Target.TargetHealthMax ) or ( CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].UseEmberKillOnTrashTargets ) ) then
            if PrimarySpell == DPET_NO_SPELL_ID then
                if ExecutePhase then
                    PrimarySpell = DPET_SHADOW_BURN_SPELL_ID
                    Description = "EMBER_KILL_SHADOWBURN"
                else
                    PrimarySpell = DPET_CHAOS_BOLT_SPELL_ID
                    Description = "EMBER_KILL_CHAOS_BOLT"
                end
            end
        end
    end
    
    return PrimarySpell, Description
end

function CBDT.StageDisplay:PrimarySpellNotification()
    
    --Проверяем инициилизированы ли уже графические элементы
    if ( not CBDT.StageDisplay.InitDone ) then
        return
    elseif ( not CBDT.IsEnabled ) then
        CBDT.StageDisplay.PrimarySpellIcon.Icon:Hide()
        return
    end
    
    --Обрабатываем отображение иконки приоритетного заклинания и проигрываем соответствующий звук
    PrimarySpellID = CBDT.StageDisplay:GetPrimarySpell()
    
    if PrimarySpellID == DPET_CHAOS_BOLT_SPELL_ID then
        if CBDT.StageDisplay.PrimarySpellIcon.IconData.IconSelector == DPET_CHAOS_BOLT_SPELL_ID then
            --Если иконка скрыта, то отображаем ее и проигрываем соответствующий звук
            if not CBDT.StageDisplay.PrimarySpellIcon.Icon:IsShown() then
                CBDT.StageDisplay.PrimarySpellIcon.Icon:Show()
                
                CBDT.SoundNotification.Replay.Pending = true
                CBDT.SoundNotification.Replay.CurrentEventSource = NSR_DPET_LEVEL_CHAOS_BOLT
            end
        else
            --Ранее отображалась другая иконка. Меняем текстуру и проигрываем соответствующий звук
            CBDT.StageDisplay.PrimarySpellIcon.IconData.IconSelector = DPET_CHAOS_BOLT_SPELL_ID
            CBDT.StageDisplay.PrimarySpellIcon.Icon:SetTexture(CBDT.StageDisplay.PrimarySpellIcon.IconData[CBDT.StageDisplay.PrimarySpellIcon.IconData.IconSelector])
            CBDT.StageDisplay.PrimarySpellIcon.Icon:Show()
            
            CBDT.SoundNotification.Replay.Pending = true
            CBDT.SoundNotification.Replay.CurrentEventSource = NSR_DPET_LEVEL_CHAOS_BOLT
        end
        
        if CBDT.SoundNotification.Replay.Pending then

            PlaySoundFile(CBDT.SoundNotification.Sounds[CBDT.SoundNotification.SelectedChaosBoltSoundIndex].SoundPath, CBDT.SoundNotification.Channels[CBDT.SoundNotification.SelectedSoundChannel])
            
            CBDT.SoundNotification.Replay.LastEventSource    = CBDT.SoundNotification.Replay.CurrentEventSource
            CBDT.SoundNotification.Replay.CurrentEventSource = NSR_NO_SOURCE
            
            CBDT.SoundNotification.Replay.Pending = false
            
            if CBDT.IsDebugEnabled then
                print(CBDT.SoundNotification.Replay.LastEventSource)
            end
        end
    elseif PrimarySpellID == DPET_SHADOW_BURN_SPELL_ID then
        if CBDT.StageDisplay.PrimarySpellIcon.IconData.IconSelector == DPET_SHADOW_BURN_SPELL_ID then
            --Если иконка скрыта, то отображаем ее и проигрываем соответствующий звук
            if not CBDT.StageDisplay.PrimarySpellIcon.Icon:IsShown() then
                CBDT.StageDisplay.PrimarySpellIcon.Icon:Show()
                
                CBDT.SoundNotification.Replay.Pending = true
                CBDT.SoundNotification.Replay.CurrentEventSource = NSR_DPET_LEVEL_SHADOWBURN
            end
        else
            --Ранее отображалась другая иконка. Меняем текстуру и проигрываем соответствующий звук
            CBDT.StageDisplay.PrimarySpellIcon.IconData.IconSelector = DPET_SHADOW_BURN_SPELL_ID
            CBDT.StageDisplay.PrimarySpellIcon.Icon:SetTexture(CBDT.StageDisplay.PrimarySpellIcon.IconData[CBDT.StageDisplay.PrimarySpellIcon.IconData.IconSelector])
            CBDT.StageDisplay.PrimarySpellIcon.Icon:Show()
            
            CBDT.SoundNotification.Replay.Pending = true
            CBDT.SoundNotification.Replay.CurrentEventSource = NSR_DPET_LEVEL_SHADOWBURN
        end
        
        if CBDT.SoundNotification.Replay.Pending then
    
            PlaySoundFile(CBDT.SoundNotification.Sounds[CBDT.SoundNotification.SelectedShadowburnSoundIndex].SoundPath, CBDT.SoundNotification.Channels[CBDT.SoundNotification.SelectedSoundChannel])
            
            CBDT.SoundNotification.Replay.LastEventSource    = CBDT.SoundNotification.Replay.CurrentEventSource
            CBDT.SoundNotification.Replay.CurrentEventSource = NSR_NO_SOURCE
            
            CBDT.SoundNotification.Replay.Pending = false
            
            if CBDT.IsDebugEnabled then
                print(CBDT.SoundNotification.Replay.LastEventSource)
            end
        end
    else
        CBDT.StageDisplay.PrimarySpellIcon.Icon:Hide()
    end
end

function CBDT.StageDisplay:Init()
    
    CBDT.StageDisplay.InitDone = false
    
    CBDT.StageDisplay.StageDescriptionFontSize.TextBoxFullHeight = math.floor( CBDT.StageDisplay.StageDescriptionFontSize.Current * 1.2 )
    
    if ( ( CBDT.StageDisplay.StageDescriptionFontSize.TextBoxFullHeight % 2 ) ~= 0 ) then
        CBDT.StageDisplay.StageDescriptionFontSize.TextBoxFullHeight = CBDT.StageDisplay.StageDescriptionFontSize.TextBoxFullHeight + 1
    end

    CBDT.StageDisplay.StageDescriptionFontSize.TextBoxHalfHeight = CBDT.StageDisplay.StageDescriptionFontSize.TextBoxFullHeight / 2
    
    for Index, StageBar in pairs( CBDT.StageDisplay.StageBars ) do
        
        if not StageBar.StageBar.Hide then
            StageBar.StageBar = CreateFrame( "StatusBar", nil, UIParent )
        end
        
        if StageBar.Description.Active then
            
            if not StageBar.Description.Text.Hide then
                StageBar.Description.Text = StageBar.StageBar:CreateFontString( nil, "OVERLAY" )
            end
            
            StageBar.Description.Text:Hide()
            
            StageBar.StageBar:SetHeight( CBDT.StageDisplay.StageBarHeight.Current + CBDT.StageDisplay.StageDescriptionFontSize.TextBoxFullHeight )
            
            StageBar.Description.Text:SetFont( "Fonts\\FRIZQT___CYR.ttf", CBDT.StageDisplay.StageDescriptionFontSize.Current, "" )
            StageBar.Description.Text:SetJustifyH( "LEFT" )
            StageBar.Description.Text:SetTextColor( StageBar.Description.InactiveColor.r,
                                                    StageBar.Description.InactiveColor.g,
                                                    StageBar.Description.InactiveColor.b,
                                                    StageBar.Description.InactiveColor.a )
            StageBar.Description.CurrentColor = COLOR_NOT_SET
            
            if Index == 1 then
                
                StageBar.StageBar:SetPoint( "CENTER", UIParent, "CENTER", CBDT.StageDisplay.StageBarOffsetX.Current, CBDT.StageDisplay.StageBarOffsetY.Current + CBDT.StageDisplay.StageDescriptionFontSize.TextBoxHalfHeight )
                StageBar.Description.Text:SetPoint( "TOPLEFT", StageBar.StageBar, "TOPLEFT", 0, 0 )
                
            elseif Index == 2 then
                
                StageBar.StageBar:SetPoint( "CENTER", UIParent, "CENTER", CBDT.StageDisplay.StageBarOffsetX.Current, CBDT.StageDisplay.StageBarOffsetY.Current - CBDT.StageDisplay.StageDescriptionFontSize.TextBoxHalfHeight )
                StageBar.Description.Text:SetPoint( "BOTTOMLEFT", StageBar.StageBar, "BOTTOMLEFT", 0, 0 )
            
            end
        else
            StageBar.StageBar:SetPoint( "CENTER", UIParent, "CENTER", CBDT.StageDisplay.StageBarOffsetX.Current, CBDT.StageDisplay.StageBarOffsetY.Current )
            StageBar.StageBar:SetHeight( CBDT.StageDisplay.StageBarHeight.Current )
            
            if StageBar.Description.Text.Hide then
                StageBar.Description.Text:Hide()
            end
        end
        
        if Index == 1 then
            
            if CBDT.StageDisplay.DPEtSpellCastLine.Active then

                if not CBDT.StageDisplay.DPEtSpellCastLine.Cl.Hide then
                    CBDT.StageDisplay.DPEtSpellCastLine.Cl = StageBar.StageBar:CreateTexture(nil, "OVERLAY")
                    CBDT.StageDisplay.DPEtSpellCastLine.Cl:SetTexture( "Interface\\AddOns\\Chaos Bolt DPET Tracker\\Textures\\Horizontal_Spark" )
                end
            
                CBDT.StageDisplay.DPEtSpellCastLine.Cl:SetPoint( "TOPLEFT", StageBar.StageBar, "BOTTOMLEFT", 0, CBDT.StageDisplay.StageBarHeight.Current )
                CBDT.StageDisplay.DPEtSpellCastLine.Cl:SetHeight( CBDT.StageDisplay.StageBarHeight.Current )
                CBDT.StageDisplay.DPEtSpellCastLine.Cl:SetVertexColor(  CBDT.StageDisplay.DPEtSpellCastLine.ActiveColor.r,
                                                                        CBDT.StageDisplay.DPEtSpellCastLine.ActiveColor.g,
                                                                        CBDT.StageDisplay.DPEtSpellCastLine.ActiveColor.b,
                                                                        CBDT.StageDisplay.DPEtSpellCastLine.ActiveColor.a )
                
                CBDT.StageDisplay.DPEtSpellCastLine.CurrentColor = COLOR_NOT_SET
                
                CBDT.StageDisplay.DPEtSpellCastLine.Cl:Hide()
            else
                if CBDT.StageDisplay.DPEtSpellCastLine.Cl.Hide then
                    CBDT.StageDisplay.DPEtSpellCastLine.Cl:Hide()
                end
            end    
        end
        
        --Общая часть инициализации прогресс индикаторов
        StageBar.StageBar:SetFrameLevel( CBDT.StageDisplay.Stages.Max - Index )
        StageBar.StageBar:SetWidth( CBDT.StageDisplay.StageBarWidth.Current )
        StageBar.StageBar:SetStatusBarTexture("Interface\\AddOns\\Chaos Bolt DPET Tracker\\Textures\\StatusBar")
        StageBar.StageBar:GetStatusBarTexture():SetHorizTile( false )
        StageBar.StageBar:GetStatusBarTexture():SetVertTile( false )
        StageBar.StageBar:SetStatusBarColor( StageBar.InactiveColor.r,
                                             StageBar.InactiveColor.g, 
                                             StageBar.InactiveColor.b,
                                             StageBar.InactiveColor.a )
        StageBar.CurrentColor = COLOR_NOT_SET
        
        StageBar.StageBar:SetMinMaxValues( 0.0, CBDT.StageDisplay.TimeWindow.Current )
        StageBar.StageBar:SetValue( 0.0 )
        
        --Инициалиация заднего фона и иконки приоритетного заклинания
        if Index == CBDT.StageDisplay.Stages.Max then

            if not CBDT.StageDisplay.StageBarBg.Bg.Hide then
                CBDT.StageDisplay.StageBarBg.Bg = StageBar.StageBar:CreateTexture( nil, "BACKGROUND" )
                CBDT.StageDisplay.StageBarBg.Bg:SetTexture( "Interface\\AddOns\\Chaos Bolt DPET Tracker\\Textures\\StatusBar" )
            end
            
            CBDT.StageDisplay.StageBarBg.Bg:SetAllPoints( true )
            CBDT.StageDisplay.StageBarBg.Bg:SetVertexColor( CBDT.StageDisplay.StageBarBg.InactiveColor.r,
                                                            CBDT.StageDisplay.StageBarBg.InactiveColor.g,
                                                            CBDT.StageDisplay.StageBarBg.InactiveColor.b,
                                                            CBDT.StageDisplay.StageBarBg.InactiveColor.a )
            CBDT.StageDisplay.StageBarBg.CurrentColor = COLOR_NOT_SET
            
            CBDT.StageDisplay.StageBarBg.Bg:Hide()
            
            --Инициализация иконки приоритетного заклинания
            CBDT.StageDisplay.PrimarySpellIcon.IconData[DPET_CHAOS_BOLT_SPELL_ID] = select( 3, GetSpellInfo( DPET_CHAOS_BOLT_SPELL_ID ) )
            CBDT.StageDisplay.PrimarySpellIcon.IconData[DPET_SHADOW_BURN_SPELL_ID] = select( 3, GetSpellInfo( DPET_SHADOW_BURN_SPELL_ID ) )
            
            if not CBDT.StageDisplay.PrimarySpellIcon.Icon.Hide then
                CBDT.StageDisplay.PrimarySpellIcon.Icon = StageBar.StageBar:CreateTexture( nil, "BACKGROUND" )
            end
            
            CBDT.StageDisplay.PrimarySpellIcon.Icon:SetTexture( CBDT.StageDisplay.PrimarySpellIcon.IconData[CBDT.StageDisplay.PrimarySpellIcon.IconData.IconSelector] )
            CBDT.StageDisplay.PrimarySpellIcon.Icon:SetSize( CBDT.StageDisplay.StageBarHeight.Current, CBDT.StageDisplay.StageBarHeight.Current )
            CBDT.StageDisplay.PrimarySpellIcon.Icon:SetPoint( "LEFT", StageBar.StageBar, "LEFT", -CBDT.StageDisplay.StageBarHeight.Current, 0 )
            CBDT.StageDisplay.PrimarySpellIcon.Icon:Hide()
        end
    end
    
    CBDT.StageDisplay.InitDone = true
end

function CBDT.StageDisplay:Update()
   
    local CastLinePosition = 0
    --Проверяем инициализированы ли все необходимые элементы
    if not CBDT.StageDisplay.InitDone then
        CBDT.StageDisplay:Init()
        return
    end
    
    --Проверяем включен ли аддон
    if not CBDT.IsEnabled then

        --Обрабатываем неактивные индикаторы
        for Index, StageBar in pairs(CBDT.StageDisplay.StageBars) do
            if StageBar.Active then
                
                StageBar.StageBar:SetValue(0.0)
                
                if ( StageBar.SelectedColor ~= COLOR_TRANSPARENT ) or ( StageBar.CurrentColor ~= StageBar.SelectedColor ) then
                    StageBar.StageBar:SetStatusBarColor( CBDT.StageDisplay.StageBars[Index].InactiveColor.r,
                                                         CBDT.StageDisplay.StageBars[Index].InactiveColor.g,
                                                         CBDT.StageDisplay.StageBars[Index].InactiveColor.b,
                                                         0 )
                    StageBar.CurrentColor = COLOR_TRANSPARENT
                    StageBar.SelectedColor = COLOR_TRANSPARENT
                end
                                                     
                if StageBar.Description.Active then
                    StageBar.Description.Text:Hide()
                end
                
                StageBar.Active = false
            end
        end
        
        if ( CBDT.StageDisplay.StageBarBg.SelectedColor ~= COLOR_TRANSPARENT ) or ( CBDT.StageDisplay.StageBarBg.CurrentColor ~= CBDT.StageDisplay.StageBarBg.SelectedColor ) then
            
            CBDT.StageDisplay.StageBarBg.Bg:SetVertexColor(1.0, 1.0, 1.0, 0.0)
            CBDT.StageDisplay.StageBarBg.CurrentColor = COLOR_TRANSPARENT
            CBDT.StageDisplay.StageBarBg.SelectedColor = COLOR_TRANSPARENT
        end
        
        if ( CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor ~= COLOR_TRANSPARENT ) or ( CBDT.StageDisplay.DPEtSpellCastLine.CurrentColor ~= CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor ) then
            
            CBDT.StageDisplay.DPEtSpellCastLine.Cl:SetVertexColor(1.0, 1.0, 1.0, 0.0)
            CBDT.StageDisplay.DPEtSpellCastLine.CurrentColor = COLOR_TRANSPARENT
            CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor = COLOR_TRANSPARENT
        end
        
        return
    end
    
    --Сбрасываем флаг активности индикаторов
    for Index, StageBar in pairs(CBDT.StageDisplay.StageBars) do
        StageBar.Active = false
    end
    
    --Устанавливаем значения по-умолчанию, если желаемых уровней DPET нет, то данные элементы будут скрыты
    CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor = COLOR_TRANSPARENT
    CBDT.StageDisplay.StageBarBg.SelectedColor = COLOR_TRANSPARENT
    
    for StageIndex, Stage in pairs(CBDT.Player.DPEtSpells[DPET_CHAOS_BOLT_SPELL_ID].DPET.Stage) do
        if Stage.Active and StageIndex <= CBDT.StageDisplay.Stages.Current then
        
            if Stage.StageRemains > CBDT.StageDisplay.TimeWindow.Current then
                CBDT.StageDisplay.StageBars[StageIndex].StageBar:SetValue(CBDT.StageDisplay.TimeWindow.Current)
            else
                CBDT.StageDisplay.StageBars[StageIndex].StageBar:SetValue(Stage.StageRemains)
            end
        
            if Stage.DPEtPct >= CBDT.StageDisplay.DPEtHighThresholdPct.Current then
                
                CBDT.StageDisplay.StageBars[StageIndex].SelectedColor = COLOR_ACTIVE
                
                if CBDT.StageDisplay.StageBars[StageIndex].Description.Active then
                    
                    CBDT.StageDisplay.StageBars[StageIndex].Description.SelectedColor = COLOR_ACTIVE
                    
                end
            
                CBDT.StageDisplay.StageBars[StageIndex].Active = true
            
                if StageIndex == 1 then
                    
                    CBDT.StageDisplay.StageBarBg.SelectedColor = COLOR_ACTIVE
                    
                    if CBDT.StageDisplay.DPEtSpellCastLine.Active then
                        
                        CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor = COLOR_ACTIVE
                        
                        --Для уменьшения эффекта блендинга текстуры устанавливаем ее положением кратным 2
                        CastLinePosition = math.floor( ( CBDT.StageDisplay.StageBarWidth.Current / CBDT.StageDisplay.TimeWindow.Current ) * Stage.CastTime )
                        
                        if ( CastLinePosition % 2 ) ~= 0 then
                            CastLinePosition = CastLinePosition + 1
                        end
                        
                        CBDT.StageDisplay.DPEtSpellCastLine.Cl:SetPoint( "TOPLEFT",
                                                                         CBDT.StageDisplay.StageBars[StageIndex].StageBar,
                                                                         "BOTTOMLEFT",
                                                                         CastLinePosition,
                                                                         CBDT.StageDisplay.StageBarHeight.Current )---CBDT.StageDisplay.StageDescriptionFontSize.TextBoxHalfHeight )
                    end
                end
            
            elseif Stage.DPEtPct >= CBDT.StageDisplay.DPEtLowThresholdPct.Current then
                
                CBDT.StageDisplay.StageBars[StageIndex].SelectedColor = COLOR_INACTIVE
                
                if CBDT.StageDisplay.StageBars[StageIndex].Description.Active then
                    
                    CBDT.StageDisplay.StageBars[StageIndex].Description.SelectedColor = COLOR_INACTIVE
                end
            
                CBDT.StageDisplay.StageBars[StageIndex].Active = true
            
                if StageIndex == 1 then
                    
                    CBDT.StageDisplay.StageBarBg.SelectedColor = COLOR_INACTIVE
                    
                    if CBDT.StageDisplay.DPEtSpellCastLine.Active then
                        
                        CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor = COLOR_INACTIVE
                        
                        --Для уменьшения эффекта блендинга текстуры устанавливаем ее положением кратным 2
                        CastLinePosition = math.floor( ( CBDT.StageDisplay.StageBarWidth.Current / CBDT.StageDisplay.TimeWindow.Current ) * Stage.CastTime )
                        
                        if ( CastLinePosition % 2 ) ~= 0 then
                            CastLinePosition = CastLinePosition + 1
                        end
                        
                        CBDT.StageDisplay.DPEtSpellCastLine.Cl:SetPoint( "TOPLEFT",
                                                                         CBDT.StageDisplay.StageBars[StageIndex].StageBar,
                                                                         "BOTTOMLEFT",
                                                                         CastLinePosition,
                                                                         CBDT.StageDisplay.StageBarHeight.Current )---CBDT.StageDisplay.StageDescriptionFontSize.TextBoxHalfHeight )
                    end
                end
            end
        
            if CBDT.StageDisplay.StageBars[StageIndex].Description.Active then
                CBDT.StageDisplay.StageBars[StageIndex].Description.Text:SetText(string.format("%2.0f%% | %.2f k\\s | %.2f k", 
                    Stage.DPEtPct * 100.0,
                    Stage.DPET * 0.001,
                    Stage.Damage * 0.001))
            
                if not CBDT.StageDisplay.StageBars[StageIndex].Description.Text:IsShown() then
                    CBDT.StageDisplay.StageBars[StageIndex].Description.Text:Show()
                end
            end
        else
            break
        end
    end
    
    --Обрабатываем неактивные индикаторы
    for Index, StageBar in pairs(CBDT.StageDisplay.StageBars) do
        if not StageBar.Active then
            
            StageBar.StageBar:SetValue(0.0)
            
            if ( StageBar.SelectedColor ~= COLOR_TRANSPARENT ) or ( StageBar.SelectedColor ~= StageBar.CurrentColor ) then
            
                StageBar.StageBar:SetStatusBarColor( CBDT.StageDisplay.StageBars[Index].InactiveColor.r,
                                                     CBDT.StageDisplay.StageBars[Index].InactiveColor.g,
                                                     CBDT.StageDisplay.StageBars[Index].InactiveColor.b,
                                                     0 )
                
                StageBar.CurrentColor = COLOR_TRANSPARENT
                StageBar.SelectedColor = COLOR_TRANSPARENT
            end

            if StageBar.Description.Active then
                StageBar.Description.Text:Hide()
            end
        else
            
            if StageBar.CurrentColor ~= StageBar.SelectedColor then
                
                if StageBar.SelectedColor == COLOR_ACTIVE then
                    
                    StageBar.StageBar:SetStatusBarColor( StageBar.ActiveColor.r, StageBar.ActiveColor.g, StageBar.ActiveColor.b, StageBar.ActiveColor.a )
                    StageBar.CurrentColor = COLOR_ACTIVE
                    
                    if StageBar.Description.Active then
                        StageBar.Description.Text:SetTextColor( StageBar.Description.ActiveColor.r, StageBar.Description.ActiveColor.g, StageBar.Description.ActiveColor.b, StageBar.Description.ActiveColor.a )
                        StageBar.Description.CurrentColor = COLOR_ACTIVE
                    end

                elseif StageBar.SelectedColor == COLOR_INACTIVE then
                    
                        StageBar.StageBar:SetStatusBarColor( StageBar.InactiveColor.r, StageBar.InactiveColor.g, StageBar.InactiveColor.b, StageBar.InactiveColor.a )
                        StageBar.CurrentColor = COLOR_INACTIVE
                    
                    if StageBar.Description.Active then
                        StageBar.Description.Text:SetTextColor( StageBar.Description.InactiveColor.r, StageBar.Description.InactiveColor.g, StageBar.Description.InactiveColor.b, StageBar.Description.InactiveColor.a )
                        StageBar.Description.CurrentColor = COLOR_INACTIVE
                    end
                end
            end
        end
    end
    
    if CBDT.StageDisplay.DPEtSpellCastLine.Active then
        
        if CBDT.StageDisplay.DPEtSpellCastLine.CurrentColor ~= CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor then
            
            if CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor == COLOR_ACTIVE then
                
                CBDT.StageDisplay.DPEtSpellCastLine.Cl:Show()
                
                CBDT.StageDisplay.DPEtSpellCastLine.Cl:SetVertexColor(  CBDT.StageDisplay.DPEtSpellCastLine.ActiveColor.r,
                                                                        CBDT.StageDisplay.DPEtSpellCastLine.ActiveColor.g,
                                                                        CBDT.StageDisplay.DPEtSpellCastLine.ActiveColor.b,
                                                                        CBDT.StageDisplay.DPEtSpellCastLine.ActiveColor.a  )
                
                CBDT.StageDisplay.DPEtSpellCastLine.CurrentColor = COLOR_ACTIVE
                
                
                
            elseif CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor == COLOR_INACTIVE then
                
                CBDT.StageDisplay.DPEtSpellCastLine.Cl:Show()
                
                CBDT.StageDisplay.DPEtSpellCastLine.Cl:SetVertexColor(  CBDT.StageDisplay.DPEtSpellCastLine.InactiveColor.r,
                                                                        CBDT.StageDisplay.DPEtSpellCastLine.InactiveColor.g,
                                                                        CBDT.StageDisplay.DPEtSpellCastLine.InactiveColor.b,
                                                                        CBDT.StageDisplay.DPEtSpellCastLine.InactiveColor.a  )
                
                CBDT.StageDisplay.DPEtSpellCastLine.CurrentColor = COLOR_INACTIVE
                
                
                
            else
                CBDT.StageDisplay.DPEtSpellCastLine.CurrentColor = COLOR_TRANSPARENT
                CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor = COLOR_TRANSPARENT
                CBDT.StageDisplay.DPEtSpellCastLine.Cl:Hide()
            end
        end
    else
        CBDT.StageDisplay.DPEtSpellCastLine.CurrentColor = COLOR_TRANSPARENT
        CBDT.StageDisplay.DPEtSpellCastLine.SelectedColor = COLOR_TRANSPARENT
        CBDT.StageDisplay.DPEtSpellCastLine.Cl:Hide()
    end
    
    if CBDT.StageDisplay.StageBarBg.CurrentColor ~= CBDT.StageDisplay.StageBarBg.SelectedColor then
        if CBDT.StageDisplay.StageBarBg.SelectedColor == COLOR_ACTIVE then
            
            CBDT.StageDisplay.StageBarBg.Bg:SetVertexColor( CBDT.StageDisplay.StageBarBg.ActiveColor.r,
                                                            CBDT.StageDisplay.StageBarBg.ActiveColor.g,
                                                            CBDT.StageDisplay.StageBarBg.ActiveColor.b,
                                                            CBDT.StageDisplay.StageBarBg.ActiveColor.a )
            
            CBDT.StageDisplay.StageBarBg.CurrentColor = COLOR_ACTIVE
            
            CBDT.StageDisplay.StageBarBg.Bg:Show()
            
        elseif CBDT.StageDisplay.StageBarBg.SelectedColor == COLOR_INACTIVE then
            
            CBDT.StageDisplay.StageBarBg.Bg:SetVertexColor( CBDT.StageDisplay.StageBarBg.InactiveColor.r,
                                                            CBDT.StageDisplay.StageBarBg.InactiveColor.g,
                                                            CBDT.StageDisplay.StageBarBg.InactiveColor.b,
                                                            CBDT.StageDisplay.StageBarBg.InactiveColor.a )
            
            CBDT.StageDisplay.StageBarBg.CurrentColor = COLOR_INACTIVE
            
            CBDT.StageDisplay.StageBarBg.Bg:Show()
        else
           CBDT.StageDisplay.StageBarBg.CurrentColor = COLOR_TRANSPARENT
           CBDT.StageDisplay.StageBarBg.SelectedColor = COLOR_TRANSPARENT
           CBDT.StageDisplay.StageBarBg.Bg:Hide()
        end
    end
end

function CBDT.Player:GetPlayerInfo()
    
    local Specialization = GetSpecialization()
    
    if Specialization then
        CBDT.Player.PlayerInfo.PlayerSpec = GetSpecializationInfo( Specialization )
    else
        CBDT.Player.PlayerInfo.PlayerSpec = CBDT.SPEC_NONE
    end
    
    if CBDT.Player.PlayerInfo[CBDT.Player.PlayerInfo.PlayerSpec] then
        CBDT.Player.PlayerInfo.PlayerMasteryMod = CBDT.Player.PlayerInfo[CBDT.Player.PlayerInfo.PlayerSpec].MasteryMod
    else
        CBDT.Player.PlayerInfo.PlayerMasteryMod = 1.0
    end
    
end

function CBDT.Player:GetRatingScaledValue( RatingValue, PLAYER_STAT_INDEX )

    if CBDT.RatingsScaling[PLAYER_STAT_INDEX] and CBDT.RatingsScaling[PLAYER_STAT_INDEX][CBDT.Player.PlayerInfo.PlayerLevel] then
        if PLAYER_STAT_INDEX == PSR_MASTERY then
            return ( ( RatingValue * CBDT.Player.PlayerInfo.PlayerMasteryMod ) / CBDT.RatingsScaling[PLAYER_STAT_INDEX][CBDT.Player.PlayerInfo.PlayerLevel] * 0.01 )
        else
            return ( RatingValue / CBDT.RatingsScaling[PLAYER_STAT_INDEX][CBDT.Player.PlayerInfo.PlayerLevel] * 0.01 )
        end
    else
        return 0.0
    end

end

function CBDT.Player:ProcessDPEtSpells()
    
    local BuffTimes = ""
    local BuffFound = false
    local SpellAffected = false
    local ProcessBuffValue = false
    
    if not CBDT.IsEnabled then
        return
    end
    
    --Обрабатываем таблицу заклинаний для которых отслеживается DPET
    for DPEtSpellID, DPEtSpell in pairs(CBDT.Player.DPEtSpells) do

        --Обнуляем таблицу уникальных баффов 
        for Index in pairs(DPEtSpell.DPET.BuffSpellID) do
            
            for SpellEffectIndex in pairs ( DPEtSpell.DPET.BuffSpellID[Index] ) do
                DPEtSpell.DPET.BuffSpellID[Index][SpellEffectIndex] = nil
            end
            
            DPEtSpell.DPET.BuffSpellID[Index] = nil
        end
        
        --Обнуляем базовые характеристики DPET уровня
        for Index in pairs(DPEtSpell.DPET.BaseValues) do
            DPEtSpell.DPET.BaseValues[Index] = 0.0
        end
        
        --Обнуляем таблицу длительностей уникальных баффов
        for Index in pairs(DPEtSpell.DPET.BuffRemains) do
            DPEtSpell.DPET.BuffRemains[Index] = nil
        end
        
        --Сбрасываем флаг активности у всех выделенных на данный момент DPET уровней
        if DPEtSpell.DPET.Stage then
            for Index in pairs(DPEtSpell.DPET.Stage) do
                DPEtSpell.DPET.Stage[Index].Active = false
            end
        end

        --Проходим по всем баффам игрока влияющим на DPET целевого заклинания и формируем таблицу оставшегося времени баффов
        --Используем группировку по SpellID, так как баффы могут иметь множественные эффекты
        for STAT_INDEX in pairs(DPEtSpell.DamageStats) do
            for BuffSpellID, BuffSpellEffects in pairs (CBDT.Player.Stats[STAT_INDEX].Buffs) do
                for SpellEffectIndex, BuffSpellEffect in pairs ( BuffSpellEffects ) do
                    --Если баффа с таким SpellID еще нет в нашей таблице, то заносим его
                    --также сохраняем его оставшееся время для дальнейшей сортировки и формирования уровней DPET
                    if BuffSpellEffect.Active and not DPEtSpell.DPET.BuffSpellID[BuffSpellID] then 
                        
                        DPEtSpell.DPET.BuffSpellID[BuffSpellID] = {}
                        
                        DPEtSpell.DPET.BuffSpellID[BuffSpellID][SpellEffectIndex] = true
                            
                        --Проверям есть ли уже такое время баффа в нашей таблице, необходимо для фильтрации перманентных баффов
                        BuffFound = false
                        for _, BuffRemains in pairs(DPEtSpell.DPET.BuffRemains) do
                            if BuffRemains == BuffSpellEffect.BuffRemains then
                                BuffFound = true
                                break
                            end
                        end
                        
                        --Если такого времени баффа нет, то добавляем
                        if not BuffFound then
                            table.insert(DPEtSpell.DPET.BuffRemains, BuffSpellEffect.BuffRemains)
                        end
                        
                        --Отладочная информация
                        if CBDT.IsDebugEnabled then
                            BuffTimes = BuffTimes .. BuffSpellID .. " - " .. BuffSpellEffect.BuffName .. "\n"
                        end
                    end
                end
            end
        end
        
        --Проверяем размер таблицы баффов влияющих на DPET целевого заклинания после обработки всех баффов
        if table.maxn( DPEtSpell.DPET.BuffRemains ) > 0 then
            --Сортируем таблицу оставшегося времени баффов
            table.sort(DPEtSpell.DPET.BuffRemains)
        else
            --Таблица баффов пуста, вставляем "виртуальный" бафф для создания уровня DPET, таким образом под индексом "1"
            --у нас всегда будет максимальный на текущий момент уровень DPET
            --в случае отсутствия баффов максимальный на текущий момент уровень DPET будет соответствовать DPET с базовыми характеристиками игрока
            table.insert(DPEtSpell.DPET.BuffRemains, 3600.0)
        end
            
        --Формируем уровни DPET на основании длительности баффов
        for StageIndex, StageRemains in pairs(DPEtSpell.DPET.BuffRemains) do
            --Используем уже выделенные элементы и инициализируем их начальными значениями
            if DPEtSpell.DPET.Stage[StageIndex] then
                
                DPEtSpell.DPET.Stage[StageIndex].StageRemains       = StageRemains
                DPEtSpell.DPET.Stage[StageIndex].Damage             = 0.0
                DPEtSpell.DPET.Stage[StageIndex].CritDamage         = 0.0
                DPEtSpell.DPET.Stage[StageIndex].DPET               = 0.0
                DPEtSpell.DPET.Stage[StageIndex].DamagePct          = 0.0
                DPEtSpell.DPET.Stage[StageIndex].DPEtPct            = 1.0
                DPEtSpell.DPET.Stage[StageIndex].AverageDamage      = 0.0
                DPEtSpell.DPET.Stage[StageIndex].AverageDPET        = 0.0
                DPEtSpell.DPET.Stage[StageIndex].CastTime           = 0.0
                DPEtSpell.DPET.Stage[StageIndex].GCDCap             = false
                DPEtSpell.DPET.Stage[StageIndex].Active             = true
                
                --Сбрасываем флаг активности бонуса по данной характеристике/рейтингу
                if DPEtSpell.DPET.Stage[StageIndex].Stats then
                    for STAT_INDEX in pairs(DPEtSpell.DPET.Stage[StageIndex].Stats) do
                        DPEtSpell.DPET.Stage[StageIndex].Stats[STAT_INDEX].Active = false
                    end
                end
            else
                --Если такого элемента таблицы уровней DPET еще не существует, то создаем его
                DPEtSpell.DPET.Stage[StageIndex] = { 
                    Active              = true,
                    StageRemains        = StageRemains,
                    Damage              = 0.0,
                    CritDamage          = 0.0,
                    DPET                = 0.0,
                    DamagePct           = 0.0,
                    DPEtPct             = 1.0,
                    AverageDamage       = 0.0,
                    AverageDPET         = 0.0,
                    CastTime            = 0.0,
                    GCDCap              = false,
                    Stats               = {} 
                }
            end
        end
        
        --Для каждого уровня обрабатываем баффы которые попадают под оставшееся время уровня
        for _, DPEtStage in pairs(DPEtSpell.DPET.Stage) do
            for STAT_INDEX in pairs(DPEtSpell.DamageStats) do
                for BuffSpellID, BuffSpellEffects in pairs (CBDT.Player.Stats[STAT_INDEX].Buffs) do
                    for _, Buff in pairs (BuffSpellEffects) do
                        if Buff.Active and Buff.BuffRemains >= DPEtStage.StageRemains then
                            
                            SpellAffected = false
                            
                            --Проверяем влияет ли этот бафф на данное заклинание или это бафф общего действия
                            if Buff.AffectingSpells then
                                
                                for _, AffectedSpellID in ipairs (Buff.AffectedSpells) do
                                    if AffectedSpellID == DPEtSpellID then
                                        SpellAffected = true
                                        break
                                    end
                                end
                            end
                            
                            --Исключаем из обработки ситуацию когда Buff.AffectingSpells == true и SpellAffected == false - данный бафф не действует на это заклинание
                            --Можно было бы просто пропустить обработку, но тогда возникает проблема синхронизации уровней, так как у одного из
                            --DPET-заклинаний может быть 3 уровня, а у другого 2
                            --Таким образом в случае пропуска будет просто уровень без изменения характеристик
                            if not ( Buff.AffectingSpells and ( not SpellAffected ) ) then
                                if BuffSpellID == CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].Backdraft.SpellID and DPEtSpellID == DPET_CHAOS_BOLT_SPELL_ID and not CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].Backdraft.UseBackdraftStacks then
                                    ProcessBuffValue = false
                                else
                                    ProcessBuffValue = true
                                end
                            else
                                ProcessBuffValue = false
                            end
                            
                            if CBDT.Player.Stats[STAT_INDEX].Type == TYPE_FLAT then
                                if Buff.Buff_Type == TYPE_FLAT then
                                   
                                    if DPEtStage.Stats[STAT_INDEX] then
                                        if DPEtStage.Stats[STAT_INDEX].Active then
                                            DPEtStage.Stats[STAT_INDEX].BuffValue      = DPEtStage.Stats[STAT_INDEX].BuffValue + ( ( ProcessBuffValue and Buff.BuffValue ) or 0 )
                                        else
                                            DPEtStage.Stats[STAT_INDEX].BuffValue      = CBDT.Player.Stats[STAT_INDEX].BaseValue + ( ( ProcessBuffValue and Buff.BuffValue ) or 0 )
                                            DPEtStage.Stats[STAT_INDEX].BuffValuePct   = 1.0
                                            DPEtStage.Stats[STAT_INDEX].StatValue      = 0.0
                                            DPEtStage.Stats[STAT_INDEX].Active         = true
                                        end
                                    else
                                        DPEtStage.Stats[STAT_INDEX] = { 
                                            Active          = true,
                                            BuffValue       = CBDT.Player.Stats[STAT_INDEX].BaseValue + ( ( ProcessBuffValue and Buff.BuffValue ) or 0 ),
                                            BuffValuePct    = 1.0, 
                                            StatValue       = 0.0
                                        }
                                    end
                                    
                                elseif Buff.Buff_Type == TYPE_PERCENTAGE then
                                    
                                    if DPEtStage.Stats[STAT_INDEX] then
                                        if DPEtStage.Stats[STAT_INDEX].Active then
                                            DPEtStage.Stats[STAT_INDEX].BuffValuePct    = DPEtStage.Stats[STAT_INDEX].BuffValuePct * ( 1.0 + ( ( ProcessBuffValue and Buff.BuffValuePct ) or 0.0 ) )
                                        else
                                            DPEtStage.Stats[STAT_INDEX].BuffValue       = CBDT.Player.Stats[STAT_INDEX].BaseValue
                                            DPEtStage.Stats[STAT_INDEX].BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct * ( 1.0 + ( ( ProcessBuffValue and Buff.BuffValuePct ) or 0.0 ) )
                                            DPEtStage.Stats[STAT_INDEX].StatValue       = 0.0
                                            DPEtStage.Stats[STAT_INDEX].Active          = true
                                        end
                                    else
                                        DPEtStage.Stats[STAT_INDEX] = {
                                            Active          = true,
                                            BuffValue       = CBDT.Player.Stats[STAT_INDEX].BaseValue,
                                            BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct * ( 1.0 + ( ( ProcessBuffValue and Buff.BuffValuePct ) or 0.0 ) ),
                                            StatValue       = 0.0
                                        }
                                    end

                                end
                            elseif CBDT.Player.Stats[STAT_INDEX].Type == TYPE_PERCENTAGE then
                                if CBDT.Player.Stats[STAT_INDEX].Mode == MODE_ADD then
                                    if Buff.Buff_Type == TYPE_FLAT then
                                        
                                        if DPEtStage.Stats[STAT_INDEX] then
                                            if DPEtStage.Stats[STAT_INDEX].Active then
                                                DPEtStage.Stats[STAT_INDEX].BuffValuePct    = DPEtStage.Stats[STAT_INDEX].BuffValuePct + ( ( ProcessBuffValue and CBDT.Player:GetRatingScaledValue( Buff.BuffValue, STAT_INDEX ) ) or 0.0 )
                                            else
                                                DPEtStage.Stats[STAT_INDEX].BuffValue       = 0
                                                DPEtStage.Stats[STAT_INDEX].BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct + ( ( ProcessBuffValue and CBDT.Player:GetRatingScaledValue( Buff.BuffValue, STAT_INDEX ) ) or 0.0 )
                                                DPEtStage.Stats[STAT_INDEX].StatValue       = 0.0
                                                DPEtStage.Stats[STAT_INDEX].Active          = true
                                            end
                                        else
                                            DPEtStage.Stats[STAT_INDEX] = {
                                                Active          = true,
                                                BuffValue       = 0,
                                                BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct + ( ( ProcessBuffValue and CBDT.Player:GetRatingScaledValue( Buff.BuffValue, STAT_INDEX ) ) or 0.0 ), 
                                                StatValue       = 0.0
                                            }
                                        end
                                        
                                    elseif Buff.Buff_Type == TYPE_PERCENTAGE then
                                        
                                        if DPEtStage.Stats[STAT_INDEX] then
                                            if DPEtStage.Stats[STAT_INDEX].Active then
                                                DPEtStage.Stats[STAT_INDEX].BuffValuePct    = DPEtStage.Stats[STAT_INDEX].BuffValuePct + ( ( ProcessBuffValue and Buff.BuffValuePct ) or 0.0 )
                                            else
                                                DPEtStage.Stats[STAT_INDEX].BuffValue       = 0
                                                DPEtStage.Stats[STAT_INDEX].BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct + ( ( ProcessBuffValue and Buff.BuffValuePct ) or 0.0 )
                                                DPEtStage.Stats[STAT_INDEX].StatValue       = 0.0
                                                DPEtStage.Stats[STAT_INDEX].Active          = true
                                            end
                                        else
                                            DPEtStage.Stats[STAT_INDEX] = {
                                                Active          = true,
                                                BuffValue       = 0,
                                                BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct + ( ( ProcessBuffValue and Buff.BuffValuePct ) or 0.0 ),
                                                StatValue       = 0.0
                                            }
                                        end
                                        
                                    end
                                elseif CBDT.Player.Stats[STAT_INDEX].Mode == MODE_MULT then
                                    if Buff.Buff_Type == TYPE_FLAT then
                                        
                                        if DPEtStage.Stats[STAT_INDEX] then
                                            if DPEtStage.Stats[STAT_INDEX].Active then
                                                DPEtStage.Stats[STAT_INDEX].BuffValuePct    = DPEtStage.Stats[STAT_INDEX].BuffValuePct + ( ( ProcessBuffValue and CBDT.Player:GetRatingScaledValue( Buff.BuffValue, STAT_INDEX ) ) or 0.0 )
                                            else
                                                DPEtStage.Stats[STAT_INDEX].BuffValue       = 0
                                                DPEtStage.Stats[STAT_INDEX].BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct + ( ( ProcessBuffValue and CBDT.Player:GetRatingScaledValue( Buff.BuffValue, STAT_INDEX ) ) or 0.0 )
                                                DPEtStage.Stats[STAT_INDEX].StatValue       = 0.0
                                                DPEtStage.Stats[STAT_INDEX].Active          = true
                                            end
                                        else
                                            DPEtStage.Stats[STAT_INDEX] = {
                                                Active          = true,
                                                BuffValue       = 0,
                                                BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct + ( ( ProcessBuffValue and CBDT.Player:GetRatingScaledValue( Buff.BuffValue, STAT_INDEX ) ) or 0.0 ), 
                                                StatValue       = 0.0
                                            }
                                        end
                                        
                                    elseif Buff.Buff_Type == TYPE_PERCENTAGE then
                                        
                                        if DPEtStage.Stats[STAT_INDEX] then
                                            if DPEtStage.Stats[STAT_INDEX].Active then
                                                DPEtStage.Stats[STAT_INDEX].BuffValuePct    = DPEtStage.Stats[STAT_INDEX].BuffValuePct * ( 1.0 + ( ( ProcessBuffValue and Buff.BuffValuePct ) or 0.0 ) )
                                            else
                                                DPEtStage.Stats[STAT_INDEX].BuffValue       = 0
                                                DPEtStage.Stats[STAT_INDEX].BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct * ( 1.0 + ( ( ProcessBuffValue and Buff.BuffValuePct ) or 0.0 ) )
                                                DPEtStage.Stats[STAT_INDEX].StatValue       = 0.0
                                                DPEtStage.Stats[STAT_INDEX].Active          = true
                                            end
                                        else
                                            DPEtStage.Stats[STAT_INDEX] = {
                                                Active          = true,
                                                BuffValue       = 0,
                                                BuffValuePct    = CBDT.Player.Stats[STAT_INDEX].BaseValuePct * ( 1.0 + ( ( ProcessBuffValue and Buff.BuffValuePct ) or 0.0 ) ),
                                                StatValue       = 0.0
                                            }
                                        end
                                        
                                    end
                                end
                            end
                        end --if Buff.Active and Buff.BuffRemains >= DPEtStage.StageRemains then
                    end--for _, Buff in pairs (BuffSpellEffects) do
                end --for _, Buff in pairs (CBDT.Player.Stats[STAT_INDEX].Buffs) do
            end --for STAT_INDEX in pairs(DPEtSpell.DamageStats) do
            
            --Итоговая обработка баффов уровня, нужна для соблюдения приоритета - сначала суммируем простые баффы, а потом применяем процентный модификатор
            for STAT_INDEX in pairs(DPEtStage.Stats) do
                if DPEtStage.Stats[STAT_INDEX].Active then
                    if CBDT.Player.Stats[STAT_INDEX].Type == TYPE_FLAT then
                        DPEtStage.Stats[STAT_INDEX].StatValue = math.ceil ( DPEtStage.Stats[STAT_INDEX].BuffValue * DPEtStage.Stats[STAT_INDEX].BuffValuePct - 0.5 )
                    elseif CBDT.Player.Stats[STAT_INDEX].Type == TYPE_PERCENTAGE then
                        DPEtStage.Stats[STAT_INDEX].StatValue = DPEtStage.Stats[STAT_INDEX].BuffValuePct
                    end
                end
            end
        end --for _, DPEtStage in pairs(DPEtSpell.DPET.Stage) do
    end --for _, DPEtSpell in pairs(CBDT.Player.DPEtSpells) do
    
    for SpellID, DPEtSpell in pairs(CBDT.Player.DPEtSpells) do
        
        local NormalHitsPct = 1.0
        
        --Расчет урона и DPET для каждого уровня "Стрела Хаоса" 
        if SpellID == DPET_CHAOS_BOLT_SPELL_ID then
            
            for _, Stage in pairs(DPEtSpell.DPET.Stage) do
                if CBDT.Player.PlayerInfo.PlayerLevel >= 80 then
                    Stage.Damage = ( 1.0 + ( DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue * ((Stage.Stats[PSR_SPELL_POWER]        and Stage.Stats[PSR_SPELL_POWER].Active         and Stage.Stats[PSR_SPELL_POWER].StatValue)        or CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue)))         *
                                   DPEtSpell.DamageStats[PSR_MASTERY].BaseValue               * ((Stage.Stats[PSR_MASTERY]            and Stage.Stats[PSR_MASTERY].Active             and Stage.Stats[PSR_MASTERY].StatValue)            or CBDT.Player.Stats[PSR_MASTERY].BaseValuePct)            *
                                   DPEtSpell.DamageStats[PSR_CRIT].BaseValue                  * ((Stage.Stats[PSR_CRIT]               and Stage.Stats[PSR_CRIT].Active                and Stage.Stats[PSR_CRIT].StatValue)               or CBDT.Player.Stats[PSR_CRIT].BaseValuePct)               *
                                   DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue           * ((Stage.Stats[PSR_VERSATILITY]        and Stage.Stats[PSR_VERSATILITY].Active         and Stage.Stats[PSR_VERSATILITY].StatValue)        or CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct)        *
                                   DPEtSpell.DamageStats[PSR_CRIT_DAMAGE_BONUS].BaseValue     * ((Stage.Stats[PSR_CRIT_DAMAGE_BONUS]  and Stage.Stats[PSR_CRIT_DAMAGE_BONUS].Active   and Stage.Stats[PSR_CRIT_DAMAGE_BONUS].StatValue)  or CBDT.Player.Stats[PSR_CRIT_DAMAGE_BONUS].BaseValuePct)  *
                                   DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue     * ((Stage.Stats[PSR_DAMAGE_DONE_BONUS]  and Stage.Stats[PSR_DAMAGE_DONE_BONUS].Active   and Stage.Stats[PSR_DAMAGE_DONE_BONUS].StatValue)  or CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct)  *
                                   2.0
                else
                    Stage.Damage = ( 1.0 + ( DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue * ((Stage.Stats[PSR_SPELL_POWER]        and Stage.Stats[PSR_SPELL_POWER].Active         and Stage.Stats[PSR_SPELL_POWER].StatValue)        or CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue)))         *
                                   DPEtSpell.DamageStats[PSR_CRIT].BaseValue                  * (((Stage.Stats[PSR_CRIT]              and Stage.Stats[PSR_CRIT].Active)               and Stage.Stats[PSR_CRIT].StatValue)               or CBDT.Player.Stats[PSR_CRIT].BaseValuePct)               *
                                   DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue           * ((Stage.Stats[PSR_VERSATILITY]        and Stage.Stats[PSR_VERSATILITY].Active         and Stage.Stats[PSR_VERSATILITY].StatValue)        or CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct)        *
                                   DPEtSpell.DamageStats[PSR_CRIT_DAMAGE_BONUS].BaseValue     * ((Stage.Stats[PSR_CRIT_DAMAGE_BONUS]  and Stage.Stats[PSR_CRIT_DAMAGE_BONUS].Active   and Stage.Stats[PSR_CRIT_DAMAGE_BONUS].StatValue)  or CBDT.Player.Stats[PSR_CRIT_DAMAGE_BONUS].BaseValuePct)  *
                                   DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue     * ((Stage.Stats[PSR_DAMAGE_DONE_BONUS]  and Stage.Stats[PSR_DAMAGE_DONE_BONUS].Active   and Stage.Stats[PSR_DAMAGE_DONE_BONUS].StatValue)  or CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct)  *
                                   2.0
                end
                
                --Фильтрация отрицательных значений
                if Stage.Damage < 0.0 then
                    Stage.Damage = 0.0
                else
                    Stage.Damage = math.ceil( Stage.Damage - 0.5 )
                end
                
                --Расчет среднего прогнозируемого урона с учетом многократной атаки
                Stage.AverageDamage = ( 1.0 + math.min(1.0, ( ( Stage.Stats[PSR_MULTISTRIKE] and Stage.Stats[PSR_MULTISTRIKE].Active and Stage.Stats[PSR_MULTISTRIKE].StatValue ) or CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct ) - 1.0 ) * 0.6 ) * Stage.Damage
                
                --Фильтрация отрицательных значений
                if Stage.AverageDamage < 0.0 then
                    Stage.AverageDamage = 0.0
                else
                    Stage.AverageDamage = math.ceil( Stage.AverageDamage - 0.5 )
                end
                
                --Время каста целевого заклинания
                Stage.CastTime = select( 4, GetSpellInfo( SpellID ) ) * 0.001
                Stage.CastTime = Stage.CastTime *
                    (
                        CBDT.Player.Stats[PSR_HASTE].BuffedValuePct /
                        ( Stage.Stats[PSR_HASTE] and Stage.Stats[PSR_HASTE].Active and Stage.Stats[PSR_HASTE].StatValue or CBDT.Player.Stats[PSR_HASTE].BaseValuePct )
                    )
                Stage.CastTime = Stage.CastTime * 
                    (
                        ( Stage.Stats[SSR_CAST_TIME_PERCENTAGE] and Stage.Stats[SSR_CAST_TIME_PERCENTAGE].Active and Stage.Stats[SSR_CAST_TIME_PERCENTAGE].StatValue or 1.0 ) /
                        ( DPEtSpell.DamageStats[SSR_CAST_TIME_PERCENTAGE].BuffValuePct )
                    )

                if Stage.CastTime < 1.0 then
                    Stage.CastTime = 1.0
                    Stage.GCDCap = true
                else
                    Stage.GCDCap = false
                end
                
                --Расчет DPET
                Stage.DPET = Stage.Damage / Stage.CastTime
                --Расчет прогнозируемого DPET
                Stage.AverageDPET = Stage.AverageDamage / Stage.CastTime
            end
            
            --Расчет базового урона и базового DPET без баффов
            if CBDT.Player.PlayerInfo.PlayerLevel >= 80 then
                DPEtSpell.DPET.BaseValues.Damage =  (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue  * CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue))         *
                                                    DPEtSpell.DamageStats[PSR_MASTERY].BaseValue              * CBDT.Player.Stats[PSR_MASTERY].BaseValuePct            *
                                                    DPEtSpell.DamageStats[PSR_CRIT].BaseValue                 * CBDT.Player.Stats[PSR_CRIT].BaseValuePct               *
                                                    DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue          * CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct        *
                                                    DPEtSpell.DamageStats[PSR_CRIT_DAMAGE_BONUS].BaseValue    * CBDT.Player.Stats[PSR_CRIT_DAMAGE_BONUS].BaseValuePct  *
                                                    DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue    * CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct  *
                                                    2.0
            else
                DPEtSpell.DPET.BaseValues.Damage =  (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue  * CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue))         *
                                                    DPEtSpell.DamageStats[PSR_CRIT].BaseValue                 * CBDT.Player.Stats[PSR_CRIT].BaseValuePct               *
                                                    DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue          * CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct        *
                                                    DPEtSpell.DamageStats[PSR_CRIT_DAMAGE_BONUS].BaseValue    * CBDT.Player.Stats[PSR_CRIT_DAMAGE_BONUS].BaseValuePct  *
                                                    DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue    * CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct  *
                                                    2.0
            end
            
            DPEtSpell.DPET.BaseValues.Damage = math.ceil( DPEtSpell.DPET.BaseValues.Damage - 0.5 )
            
            --Расчет среднего прогнозируемого урона с учетом многократной атаки
            DPEtSpell.DPET.BaseValues.AverageDamage = ( 1.0 + math.min(1.0, CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct - 1.0 ) * 0.6 ) * DPEtSpell.DPET.BaseValues.Damage
            
            --Фильтрация отрицательных значений
            if DPEtSpell.DPET.BaseValues.AverageDamage < 0.0 then
                DPEtSpell.DPET.BaseValues.AverageDamage = 0.0
            else
                DPEtSpell.DPET.BaseValues.AverageDamage = math.ceil( DPEtSpell.DPET.BaseValues.AverageDamage - 0.5 )
            end
            
            DPEtSpell.DPET.BaseValues.CastTime = select( 4, GetSpellInfo( SpellID ) ) * 0.001
            
            DPEtSpell.DPET.BaseValues.CastTime = DPEtSpell.DPET.BaseValues.CastTime *
                (
                    CBDT.Player.Stats[PSR_HASTE].BuffedValuePct /
                    CBDT.Player.Stats[PSR_HASTE].BaseValuePct
                )
            DPEtSpell.DPET.BaseValues.CastTime = DPEtSpell.DPET.BaseValues.CastTime / DPEtSpell.DamageStats[SSR_CAST_TIME_PERCENTAGE].BuffValuePct

            
            if ( DPEtSpell.DPET.BaseValues.CastTime < 1.0) then
                DPEtSpell.DPET.BaseValues.CastTime = 1.0
            end
            
            --Расчет базового DPET
            DPEtSpell.DPET.BaseValues.DPET =  DPEtSpell.DPET.BaseValues.Damage /  DPEtSpell.DPET.BaseValues.CastTime
            --Расчет прогнозируемого DPET
            DPEtSpell.DPET.BaseValues.AverageDPET = DPEtSpell.DPET.BaseValues.AverageDamage / DPEtSpell.DPET.BaseValues.CastTime
           
           --Обрабатываем все уровни расчитываем процентное отношение к базовому урону и DPET
            for _, Stage in pairs(DPEtSpell.DPET.Stage) do
                Stage.DamagePct = Stage.Damage / DPEtSpell.DPET.BaseValues.Damage
                Stage.DPEtPct   = math.ceil( ( Stage.DPET / DPEtSpell.DPET.BaseValues.DPET ) * 100.0 - 0.5) / 100.0
            end
        --Расчет урона и DPET для каждого уровня "Ожог Тьмы"
        elseif SpellID == DPET_SHADOW_BURN_SPELL_ID then
            
            for _, Stage in pairs(DPEtSpell.DPET.Stage) do
                if CBDT.Player.PlayerInfo.PlayerLevel >= 80 then
                    Stage.Damage = (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue   * ((Stage.Stats[PSR_SPELL_POWER]        and Stage.Stats[PSR_SPELL_POWER].Active         and Stage.Stats[PSR_SPELL_POWER].StatValue)        or CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue)))        *
                                   DPEtSpell.DamageStats[PSR_MASTERY].BaseValue               * ((Stage.Stats[PSR_MASTERY]            and Stage.Stats[PSR_MASTERY].Active             and Stage.Stats[PSR_MASTERY].StatValue)            or CBDT.Player.Stats[PSR_MASTERY].BaseValuePct)           *
                                   DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue           * ((Stage.Stats[PSR_VERSATILITY]        and Stage.Stats[PSR_VERSATILITY].Active         and Stage.Stats[PSR_VERSATILITY].StatValue)        or CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct)       *
                                   DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue     * ((Stage.Stats[PSR_DAMAGE_DONE_BONUS]  and Stage.Stats[PSR_DAMAGE_DONE_BONUS].Active   and Stage.Stats[PSR_DAMAGE_DONE_BONUS].StatValue)  or CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct)
                else
                    Stage.Damage = (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue   * ((Stage.Stats[PSR_SPELL_POWER]        and Stage.Stats[PSR_SPELL_POWER].Active         and Stage.Stats[PSR_SPELL_POWER].StatValue)        or CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue)))        *
                                   DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue     * ((Stage.Stats[PSR_DAMAGE_DONE_BONUS]  and Stage.Stats[PSR_DAMAGE_DONE_BONUS].Active   and Stage.Stats[PSR_DAMAGE_DONE_BONUS].StatValue)  or CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct) *
                                   DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue           * ((Stage.Stats[PSR_VERSATILITY]        and Stage.Stats[PSR_VERSATILITY].Active         and Stage.Stats[PSR_VERSATILITY].StatValue)        or CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct)
                end
                
                --Фильтрация отрицательных значений
                if Stage.Damage < 0.0 then
                    Stage.Damage = 0.0
                else
                    Stage.Damage = math.ceil( Stage.Damage - 0.5 )
                end

                --Расчет критического урона
                Stage.CritDamage = Stage.Damage * ( ( Stage.Stats[PSR_CRIT_DAMAGE_BONUS] and Stage.Stats[PSR_CRIT_DAMAGE_BONUS].Active and Stage.Stats[PSR_CRIT_DAMAGE_BONUS].StatValue ) or CBDT.Player.Stats[PSR_CRIT_DAMAGE_BONUS].BaseValuePct ) * 2.0
                
                --Процентное соотношение обычных/критических попаданий
                NormalHitsPct = math.max(0.0, 2.0 - ( ( ( Stage.Stats[PSR_CRIT] and Stage.Stats[PSR_CRIT].Active ) and Stage.Stats[PSR_CRIT].StatValue ) or CBDT.Player.Stats[PSR_CRIT].BaseValuePct ) )
                
                --Расчет среднего урона с учетом возможных критических попаданий как прямого урона так и урона от многократной атаки
                Stage.AverageDamage = ( Stage.Damage * NormalHitsPct + Stage.CritDamage * ( 1.0 - NormalHitsPct ) ) +
                                      ( 
                                        math.min( 1.0, ( ( Stage.Stats[PSR_MULTISTRIKE] and Stage.Stats[PSR_MULTISTRIKE].Active and Stage.Stats[PSR_MULTISTRIKE].StatValue ) or CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct ) - 1.0 ) * 0.6 * Stage.Damage * NormalHitsPct + 
                                        math.min( 1.0, ( ( Stage.Stats[PSR_MULTISTRIKE] and Stage.Stats[PSR_MULTISTRIKE].Active and Stage.Stats[PSR_MULTISTRIKE].StatValue ) or CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct ) - 1.0 ) * 0.6 * Stage.CritDamage * ( 1.0 - NormalHitsPct )
                                      )
                
                --Фильтрация отрицательных значений
                if Stage.AverageDamage < 0.0 then
                    Stage.AverageDamage = 0.0
                else
                    Stage.AverageDamage = math.ceil( Stage.AverageDamage - 0.5 )
                end
                
                --Время каста целевого заклинания, так как заклинание мгновенное принимаем за время каста текущее значение ГКД
                Stage.CastTime = 1.5 / ( ( Stage.Stats[PSR_HASTE] and Stage.Stats[PSR_HASTE].Active and Stage.Stats[PSR_HASTE].StatValue or CBDT.Player.Stats[PSR_HASTE].BaseValuePct ) )

                if Stage.CastTime < 1.0 then
                    Stage.CastTime = 1.0
                end
                
                --Расчет DPET
                Stage.DPET = Stage.Damage / Stage.CastTime
                --Расчет прогнозируемого DPET
                Stage.AverageDPET = Stage.AverageDamage / Stage.CastTime
            end
            
            --Расчет базового урона и базового DPET без баффов
            if CBDT.Player.PlayerInfo.PlayerLevel >= 80 then
                DPEtSpell.DPET.BaseValues.Damage =  (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue  * CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue))         *
                                                    DPEtSpell.DamageStats[PSR_MASTERY].BaseValue              * CBDT.Player.Stats[PSR_MASTERY].BaseValuePct            *
                                                    DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue          * CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct        *
                                                    DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue    * CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct
            else
                DPEtSpell.DPET.BaseValues.Damage =  (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue  * CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue))         *
                                                    DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue          * CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct        *
                                                    DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue    * CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct
            end
            
            DPEtSpell.DPET.BaseValues.Damage = math.ceil( DPEtSpell.DPET.BaseValues.Damage - 0.5 )
            
            --Расчет критического урона
            DPEtSpell.DPET.BaseValues.CritDamage = ( DPEtSpell.DPET.BaseValues.Damage * CBDT.Player.Stats[PSR_CRIT_DAMAGE_BONUS].BaseValuePct ) * 2.0
            
            --Процентное соотношение обычных/критических попаданий
            NormalHitsPct = math.max(0.0, 2.0 - ( CBDT.Player.Stats[PSR_CRIT].BaseValuePct ) )
            
            --Расчет среднего урона с учетом возможных критических попаданий как прямого урона так и урона от многократной атаки
            DPEtSpell.DPET.BaseValues.AverageDamage = ( DPEtSpell.DPET.BaseValues.Damage * NormalHitsPct + DPEtSpell.DPET.BaseValues.CritDamage * ( 1.0 - NormalHitsPct ) ) +
                                      ( 
                                        math.min( 1.0, CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct - 1.0 ) * 0.6 * DPEtSpell.DPET.BaseValues.Damage * NormalHitsPct + 
                                        math.min( 1.0, CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct - 1.0 ) * 0.6 * DPEtSpell.DPET.BaseValues.CritDamage * ( 1.0 - NormalHitsPct )
                                      )
            
            --Фильтрация отрицательных значений
            if DPEtSpell.DPET.BaseValues.AverageDamage < 0.0 then
                DPEtSpell.DPET.BaseValues.AverageDamage = 0.0
            else
                DPEtSpell.DPET.BaseValues.AverageDamage = math.ceil( DPEtSpell.DPET.BaseValues.AverageDamage - 0.5 )
            end
            
            DPEtSpell.DPET.BaseValues.CastTime = 1.5 / CBDT.Player.Stats[PSR_HASTE].BaseValuePct
            
            if ( DPEtSpell.DPET.BaseValues.CastTime < 1.0) then
                     DPEtSpell.DPET.BaseValues.CastTime = 1.0
            end
            
            --Расчет базового DPET
            DPEtSpell.DPET.BaseValues.DPET =  DPEtSpell.DPET.BaseValues.Damage /  DPEtSpell.DPET.BaseValues.CastTime
            --Расчет прогнозируемого DPET
            DPEtSpell.DPET.BaseValues.AverageDPET = DPEtSpell.DPET.BaseValues.AverageDamage / DPEtSpell.DPET.BaseValues.CastTime
           
            --Обрабатываем все уровни расчитываем процентное отношение к базовому урону и DPET
            for _, Stage in pairs(DPEtSpell.DPET.Stage) do
                Stage.DamagePct = Stage.Damage / DPEtSpell.DPET.BaseValues.Damage
                Stage.DPEtPct   = math.ceil( ( Stage.DPET / DPEtSpell.DPET.BaseValues.DPET ) * 100.0 - 0.5) / 100.0
            end
		--Расчет урона и DPET для каждого уровня "Испепеления"
        elseif SpellID == DPET_INCINERATE_SPELL_ID then
            local NormalHitsPct = 1.0
            local EffectiveMastery = 1.0
            for _, Stage in pairs(DPEtSpell.DPET.Stage) do
                if CBDT.Player.PlayerInfo.PlayerLevel >= 80 then
                    
                    --Искусность для "Испепелиния" учмитывается по-другому
                    if Stage.Stats[PSR_MASTERY] and Stage.Stats[PSR_MASTERY].Active then
                        EffectiveMastery = CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].NonEmberBaseMastery + ( ( Stage.Stats[PSR_MASTERY].StatValue - CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaseMastery ) / CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].MasteryMod )
                    else
                        EffectiveMastery = CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].NonEmberBaseMastery + ( ( CBDT.Player.Stats[PSR_MASTERY].BaseValuePct - CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaseMastery ) / CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].MasteryMod )
                    end
                        
                    
                    Stage.Damage = (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue   * ((Stage.Stats[PSR_SPELL_POWER]        and Stage.Stats[PSR_SPELL_POWER].Active         and Stage.Stats[PSR_SPELL_POWER].StatValue)        or CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue)))         *
                                   DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue           * ((Stage.Stats[PSR_VERSATILITY]        and Stage.Stats[PSR_VERSATILITY].Active         and Stage.Stats[PSR_VERSATILITY].StatValue)        or CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct)        *
                                   DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue     * ((Stage.Stats[PSR_DAMAGE_DONE_BONUS]  and Stage.Stats[PSR_DAMAGE_DONE_BONUS].Active   and Stage.Stats[PSR_DAMAGE_DONE_BONUS].StatValue)  or CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct)  *
                                   DPEtSpell.DamageStats[PSR_MASTERY].BaseValue               * EffectiveMastery
                else
                    Stage.Damage = (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue   * ((Stage.Stats[PSR_SPELL_POWER]        and Stage.Stats[PSR_SPELL_POWER].Active         and Stage.Stats[PSR_SPELL_POWER].StatValue)        or CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue)))         *
                                   DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue     * ((Stage.Stats[PSR_DAMAGE_DONE_BONUS]  and Stage.Stats[PSR_DAMAGE_DONE_BONUS].Active   and Stage.Stats[PSR_DAMAGE_DONE_BONUS].StatValue)  or CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct)  *
                                   DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue           * ((Stage.Stats[PSR_VERSATILITY]        and Stage.Stats[PSR_VERSATILITY].Active         and Stage.Stats[PSR_VERSATILITY].StatValue)        or CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct)
                end
                
                --Фильтрация отрицательных значений
                if Stage.Damage < 0.0 then
                    Stage.Damage = 0.0
                else
                    Stage.Damage = math.ceil( Stage.Damage - 0.5 )
                end

                --Расчет критического урона
                Stage.CritDamage = Stage.Damage * ( ( Stage.Stats[PSR_CRIT_DAMAGE_BONUS] and Stage.Stats[PSR_CRIT_DAMAGE_BONUS].Active and Stage.Stats[PSR_CRIT_DAMAGE_BONUS].StatValue ) or CBDT.Player.Stats[PSR_CRIT_DAMAGE_BONUS].BaseValuePct ) * 2.0
                
                --Процентное соотношение обычных/критических попаданий
                NormalHitsPct = math.max(0.0, 2.0 - ( ( ( Stage.Stats[PSR_CRIT] and Stage.Stats[PSR_CRIT].Active ) and Stage.Stats[PSR_CRIT].StatValue ) or CBDT.Player.Stats[PSR_CRIT].BaseValuePct ) )
                
                --Расчет среднего урона с учетом возможных критических попаданий как прямого урона так и урона от многократной атаки
                Stage.AverageDamage = ( Stage.Damage * NormalHitsPct + Stage.CritDamage * ( 1.0 - NormalHitsPct ) ) +
                                      ( 
                                        math.min( 1.0, ( ( Stage.Stats[PSR_MULTISTRIKE] and Stage.Stats[PSR_MULTISTRIKE].Active and Stage.Stats[PSR_MULTISTRIKE].StatValue ) or CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct ) - 1.0 ) * 0.6 * Stage.Damage * NormalHitsPct + 
                                        math.min( 1.0, ( ( Stage.Stats[PSR_MULTISTRIKE] and Stage.Stats[PSR_MULTISTRIKE].Active and Stage.Stats[PSR_MULTISTRIKE].StatValue ) or CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct ) - 1.0 ) * 0.6 * Stage.CritDamage * ( 1.0 - NormalHitsPct )
                                      )
                
                --Фильтрация отрицательных значений
                if Stage.AverageDamage < 0.0 then
                    Stage.AverageDamage = 0.0
                else
                    Stage.AverageDamage = math.ceil( Stage.AverageDamage - 0.5 )
                end
                
                --Время каста целевого заклинания
                Stage.CastTime = select( 4, GetSpellInfo( SpellID ) ) * 0.001
                
                Stage.CastTime = Stage.CastTime * 
                    (
                        CBDT.Player.Stats[PSR_HASTE].BuffedValuePct /
                        ( Stage.Stats[PSR_HASTE] and Stage.Stats[PSR_HASTE].Active and Stage.Stats[PSR_HASTE].StatValue or CBDT.Player.Stats[PSR_HASTE].BaseValuePct )
                    )
                Stage.CastTime = Stage.CastTime * 
                    (
                        ( Stage.Stats[SSR_CAST_TIME_PERCENTAGE] and Stage.Stats[SSR_CAST_TIME_PERCENTAGE].Active and Stage.Stats[SSR_CAST_TIME_PERCENTAGE].StatValue or 1.0 ) /
                        ( DPEtSpell.DamageStats[SSR_CAST_TIME_PERCENTAGE].BuffValuePct )
                    )

                if Stage.CastTime < 1.0 then
                    Stage.CastTime = 1.0
                    Stage.GCDCap = true
                else
                    Stage.GCDCap = false
                end
                
                --Расчет DPET
                Stage.DPET = Stage.Damage / Stage.CastTime
                --Расчет прогнозируемого DPET
                Stage.AverageDPET = Stage.AverageDamage / Stage.CastTime
            end
            
            --Расчет базового урона и базового DPET без баффов
            if CBDT.Player.PlayerInfo.PlayerLevel >= 80 then
                
                --Искусность для "Испепелиния" учмитывается по-другому
                EffectiveMastery = CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].NonEmberBaseMastery + ( ( CBDT.Player.Stats[PSR_MASTERY].BaseValuePct - CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BaseMastery ) / CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].MasteryMod )
                
                DPEtSpell.DPET.BaseValues.Damage =  (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue    * CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue))         *
                                                    DPEtSpell.DamageStats[PSR_MASTERY].BaseValue                * EffectiveMastery                                       *
                                                    DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue            * CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct        *
                                                    DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue      * CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct
            else
                DPEtSpell.DPET.BaseValues.Damage =  (1.0 + (DPEtSpell.DamageStats[PSR_SPELL_POWER].BaseValue    * CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue))         *
                                                    DPEtSpell.DamageStats[PSR_VERSATILITY].BaseValue            * CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct           *
                                                    DPEtSpell.DamageStats[PSR_DAMAGE_DONE_BONUS].BaseValue      * CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct

            end
            
            DPEtSpell.DPET.BaseValues.Damage = math.ceil( DPEtSpell.DPET.BaseValues.Damage - 0.5 )
            
            --Расчет критического урона
            DPEtSpell.DPET.BaseValues.CritDamage = ( DPEtSpell.DPET.BaseValues.Damage * CBDT.Player.Stats[PSR_CRIT_DAMAGE_BONUS].BaseValuePct ) * 2.0
            
            --Процентное соотношение обычных/критических попаданий
            NormalHitsPct = math.max(0.0, 2.0 - ( CBDT.Player.Stats[PSR_CRIT].BaseValuePct ) )
            
            --Расчет среднего урона с учетом возможных критических попаданий как прямого урона так и урона от многократной атаки
            DPEtSpell.DPET.BaseValues.AverageDamage = ( DPEtSpell.DPET.BaseValues.Damage * NormalHitsPct + DPEtSpell.DPET.BaseValues.CritDamage * ( 1.0 - NormalHitsPct ) ) +
                                      ( 
                                        math.min( 1.0, CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct - 1.0 ) * 0.6 * DPEtSpell.DPET.BaseValues.Damage * NormalHitsPct + 
                                        math.min( 1.0, CBDT.Player.Stats[PSR_MULTISTRIKE].BaseValuePct - 1.0 ) * 0.6 * DPEtSpell.DPET.BaseValues.CritDamage * ( 1.0 - NormalHitsPct )
                                      )
            
            --Фильтрация отрицательных значений
            if DPEtSpell.DPET.BaseValues.AverageDamage < 0.0 then
                DPEtSpell.DPET.BaseValues.AverageDamage = 0.0
            else
                DPEtSpell.DPET.BaseValues.AverageDamage = math.ceil( DPEtSpell.DPET.BaseValues.AverageDamage - 0.5 )
            end
            
            DPEtSpell.DPET.BaseValues.CastTime = select( 4, GetSpellInfo( SpellID ) ) * 0.001
            
            DPEtSpell.DPET.BaseValues.CastTime = DPEtSpell.DPET.BaseValues.CastTime * 
                (
                    CBDT.Player.Stats[PSR_HASTE].BuffedValuePct /
                    CBDT.Player.Stats[PSR_HASTE].BaseValuePct
                )

            DPEtSpell.DPET.BaseValues.CastTime = DPEtSpell.DPET.BaseValues.CastTime / DPEtSpell.DamageStats[SSR_CAST_TIME_PERCENTAGE].BuffValuePct
            
            if ( DPEtSpell.DPET.BaseValues.CastTime < 1.0) then
                DPEtSpell.DPET.BaseValues.CastTime = 1.0
            end

            
            --Расчет базового DPET
            DPEtSpell.DPET.BaseValues.DPET =  DPEtSpell.DPET.BaseValues.Damage /  DPEtSpell.DPET.BaseValues.CastTime
            --Расчет прогнозируемого DPET
            DPEtSpell.DPET.BaseValues.AverageDPET = DPEtSpell.DPET.BaseValues.AverageDamage / DPEtSpell.DPET.BaseValues.CastTime
            
            --Обрабатываем все уровни расчитываем процентное отношение к базовому урону и DPET
            for _, Stage in pairs(DPEtSpell.DPET.Stage) do
                Stage.DamagePct = Stage.Damage / DPEtSpell.DPET.BaseValues.Damage
                Stage.DPEtPct   = math.ceil( ( Stage.DPET / DPEtSpell.DPET.BaseValues.DPET ) * 100.0 - 0.5) / 100.0
            end
        end--if SpellID == DPET_CHAOS_BOLT_SPELL_ID then
    end
    
    --Отладочная информация
    if CBDT.IsDebugEnabled then
        for SpellID, DPEtSpell in pairs(CBDT.Player.DPEtSpells) do
            BuffTimes = BuffTimes .. "\n" .. DPEtSpell.Name .."\n"
            for StageIndex, Stage in pairs(DPEtSpell.DPET.Stage) do
                if Stage.Active then
                    BuffTimes = BuffTimes .. string.format("Stage: %d | Time remain: %07.2f | Damage: %07.2f | ADMG: %07.2f | ADPET: %07.2f | DPET: %07.2f | Base DPET: %07.2f | DPET %%: %07.2f\n              | CastTime: %4.2f | Base Damage: %07.2f | Base CastTime %4.2f\nSP: %4.2f MST: %4.2f%% | CR: %4.2f%% | VRS: %4.2f%% | CR_B: %4.2f%% DMG_B: %4.2f%%\n",
                                                StageIndex, 
                                                Stage.StageRemains,
                                                Stage.Damage,
                                                Stage.AverageDamage,
                                                Stage.AverageDPET,
                                                Stage.DPET,
                                                DPEtSpell.DPET.BaseValues.DPET,
                                                Stage.DPEtPct * 100.0,
                                                Stage.CastTime,
                                                DPEtSpell.DPET.BaseValues.Damage,
                                                DPEtSpell.DPET.BaseValues.CastTime,
                                                CBDT.Player.Stats[PSR_SPELL_POWER].BaseValue,
                                                ( CBDT.Player.Stats[PSR_MASTERY].BaseValuePct - 1.0 ) * 100.0,
                                                ( CBDT.Player.Stats[PSR_CRIT].BaseValuePct - 1.0 ) * 100.0,
                                                ( CBDT.Player.Stats[PSR_VERSATILITY].BaseValuePct - 1.0 ) * 100.0,
                                                ( CBDT.Player.Stats[PSR_CRIT_DAMAGE_BONUS].BaseValuePct - 1.0 ) * 100.0,
                                                ( CBDT.Player.Stats[PSR_DAMAGE_DONE_BONUS].BaseValuePct - 1.0 ) * 100.0 )

                    for STAT_INDEX, StageStat in pairs(DPEtSpell.DPET.Stage[StageIndex].Stats) do
                        if StageStat.Active then
                            BuffTimes = BuffTimes .. string.format("%s: %6.2f = { BaseValue: %6.2f, BuffValue: %6.2f, BuffValuePct: %6.2f }\n",
                            CBDT.Player.Stats[STAT_INDEX].Name,
                            StageStat.StatValue,
                            DPEtSpell.DamageStats[STAT_INDEX].BaseValue,
                            DPEtSpell.DamageStats[STAT_INDEX].BuffValue,
                            DPEtSpell.DamageStats[STAT_INDEX].BuffValuePct)
                        end
                    end
                end
            end
        end
        
        --Отладочная информация
        local PrimarySpell, Description = CBDT.StageDisplay:GetPrimarySpell()
   
        if PrimarySpell == DPET_CHAOS_BOLT_SPELL_ID then
            BuffTimes = BuffTimes .. "\nСтрела Хаоса " .. Description
        elseif PrimarySpell == DPET_SHADOW_BURN_SPELL_ID then
            BuffTimes = BuffTimes .. "\nОжог Тьмы " .. Description
        else
            BuffTimes = BuffTimes .. "\nНет заклинания " .. Description
        end
        
        BuffTimes = BuffTimes .. " [ " ..CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BurningEmberBits .. " ]"

        CBDT_EventFrame.DebugText:SetText(BuffTimes)
    end
end

function CBDT.Player:GetBaseStats()
    CBDT.Player.Stats[PSR_STRENGTH].BuffedValue     = UnitStat("player", PSR_STRENGTH)
    CBDT.Player.Stats[PSR_AGILITY].BuffedValue      = UnitStat("player", PSR_AGILITY)
    CBDT.Player.Stats[PSR_STAMINA].BuffedValue      = UnitStat("player", PSR_STAMINA)
    CBDT.Player.Stats[PSR_INTELLECT].BuffedValue    = UnitStat("player", PSR_INTELLECT)
    CBDT.Player.Stats[PSR_SPIRIT].BuffedValue       = UnitStat("player", PSR_SPIRIT)
    CBDT.Player.Stats[PSR_SPELL_POWER].BuffedValue  = GetSpellBonusDamage(6)
    CBDT.Player.Stats[PSR_ATTACK_POWER].BuffedValue = 1.0 + (UnitAttackPower("player") * 0.01)    

    CBDT.Player.Stats[PSR_CRIT].BuffedValuePct         = 1.0 + (GetSpellCritChance(6) * 0.01)
    CBDT.Player.Stats[PSR_MULTISTRIKE].BuffedValuePct  = 1.0 + (GetMultistrike() * 0.01)
    CBDT.Player.Stats[PSR_READINESS].BuffedValuePct    = 1.0 + (GetCombatRatingBonus(CR_READINESS) * 0.01)
    CBDT.Player.Stats[PSR_HASTE].BuffedValuePct        = 1.0 + (GetCombatRatingBonus(CR_HASTE_SPELL) * 0.01)
    CBDT.Player.Stats[PSR_LEECH].BuffedValuePct        = 1.0 + (GetCombatRatingBonus(CR_LIFESTEAL) * 0.01)
    CBDT.Player.Stats[PSR_EXPERTISE].BuffedValuePct    = 1.0 + (GetCombatRatingBonus(CR_EXPERTISE ) * 0.01)
    CBDT.Player.Stats[PSR_MASTERY].BuffedValuePct      = 1.0 + (GetMasteryEffect() * 0.01)
    CBDT.Player.Stats[PSR_VERSATILITY].BuffedValuePct  = 1.0 + (GetCombatRatingBonus(CR_VERSATILITY_DAMAGE_DONE) * 0.01)

    for STAT_NAME, PlayerStat in pairs(CBDT.Player.Stats) do
        
        if (STAT_NAME == PSR_CRIT_DAMAGE_BONUS) or (STAT_NAME == PSR_CRIT_HEALING_BONUS) then
            PlayerStat.BuffedValuePct = PlayerStat.BuffValuePct * CBDT.Player.GearSpecific.MetagemCritEffect * CBDT.Player.GearSpecific.AmplificationEffect
        elseif STAT_NAME == PSR_DAMAGE_DONE_BONUS then
            PlayerStat.BuffedValuePct = PlayerStat.BuffValuePct
        end
        
        if PlayerStat.Type == TYPE_FLAT then

            PlayerStat.BaseValue = math.ceil ( ((PlayerStat.BuffedValue / PlayerStat.BuffValuePct) - PlayerStat.BuffValue) - 0.5 )
        
        elseif PlayerStat.Type == TYPE_PERCENTAGE then
            if PlayerStat.Mode == MODE_ADD then
               
                if PlayerStat.BuffValue ~= 0 then
                    PlayerStat.BuffValuePct = PlayerStat.BuffValuePct + CBDT.Player:GetRatingScaledValue( PlayerStat.BuffValue, STAT_NAME )
                    PlayerStat.BaseValuePct = PlayerStat.BuffedValuePct - ( PlayerStat.BuffValuePct - 1.0 )
                else
                    PlayerStat.BaseValuePct = PlayerStat.BuffedValuePct - ( PlayerStat.BuffValuePct - 1.0 )
                end
                
            elseif PlayerStat.Mode == MODE_MULT then
                
                if PlayerStat.BuffValue ~= 0 then
                    PlayerStat.BaseValuePct = (PlayerStat.BuffedValuePct / PlayerStat.BuffValuePct) - CBDT.Player:GetRatingScaledValue( PlayerStat.BuffValue, STAT_NAME )
                    PlayerStat.BuffValuePct = PlayerStat.BuffedValuePct - PlayerStat.BaseValuePct
                else
                    PlayerStat.BaseValuePct = PlayerStat.BuffedValuePct / PlayerStat.BuffValuePct
                end
            end
        end
    end
end

function CBDT.Player:ProcessBuffs()
    
    local ScaledValue               = 0.0
    local MaxScalingLevel           = 0
    local PLAYER_STAT_INDEX         = 0
    local BuffRemains               = 0.0
    local BuffExpires               = 0.0
    local CurrentTime               = 0.0
    local SpellSourceItemLevel      = 0
    local SpellSourceItemEquipped   = false
    local SpellSourceItemQuality    = 0
    local SpellSourceItemBudget     = 0
   
    if CBDT.SpellEffectsData[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] then
        for _, SpellEffect in ipairs(CBDT.SpellEffectsData[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]]) do
               
            --Обрабатываем ли мы такой эффект, например A_MOD_STAT
            if CBDT.SpellEffects[SpellEffect.Type] then
                
                local PlayerAuraFilled = false
                
                for Index = UNIT_AURA_VALUE_OFFSET, table.maxn(CBDT.Player.Auras.PlayerAura) do
                    if CBDT.Player.Auras.PlayerAura[Index] ~= 0 then
                        PlayerAuraFilled = true
                        break
                    end
                end
                
                if PlayerAuraFilled then
                    ScaledValue = CBDT.Player.Auras.PlayerAura[SpellEffect.Index + UNIT_AURA_VALUE_OFFSET]
                else
                    --Проверка режима масштабирования
                    if SpellEffect.ScalingType >= 0 then
                        --Значение не масштабируется - используется BaseValue
                        ScaledValue = SpellEffect.BaseValue * max( CBDT.Player.Auras.PlayerAura[UNIT_AURA_STACKS], 1 )
                    else
                        --Значение масштабируется - используется указанная таблица масштабирования и уровень персонажа
                        if SpellEffect.MaxScalingLevel == 0 then
                            MaxScalingLevel = CBDT.Player.PlayerInfo.PlayerLevel
                        else
                            MaxScalingLevel = min( CBDT.Player.PlayerInfo.PlayerLevel, SpellEffect.MaxScalingLevel )
                        end

                        --Данный эффект генерируется предметом экипировки, проверяем есть ли у персонажа предмет с таким ItemID
                        SpellSourceItemEquipped = false
                        if SpellEffect.SpellSourceItems and CBDT.Player.Equipment.EquipmentInfoUpdated then
                            for _, EquipmentSlot in pairs ( CBDT.Player.Equipment.Inventory ) do
                                if EquipmentSlot.SlotEquipped then
                                    for _, SpellSourceItemID in pairs ( SpellEffect.SpellSourceItemList ) do
                                        if EquipmentSlot.ItemID == SpellSourceItemID then
                                            SpellSourceItemEquipped = true
                                            SpellSourceItemLevel    = EquipmentSlot.ItemLevel
                                            SpellSourceItemQuality  = EquipmentSlot.ItemQuality
                                            break
                                        end
                                    end
                                end
                            end
                        end
                        
                        --Выбираем тип масштабирования, если эффект от предмета экипировки то масштабируем по ilvl, если нет, то стандартное масштабирование
                        if SpellSourceItemEquipped then
                            
                            if SpellSourceItemQuality == ITEM_QUALITY_UNCOMMON then
                                SpellSourceItemBudget = CBDT.ItemBudget[SpellSourceItemLevel].UncommonQuality[1]
                            elseif SpellSourceItemQuality == ITEM_QUALITY_RARE then
                                SpellSourceItemBudget = CBDT.ItemBudget[SpellSourceItemLevel].RareQuality[1]
                            elseif SpellSourceItemQuality > ITEM_QUALITY_RARE then
                                SpellSourceItemBudget = CBDT.ItemBudget[SpellSourceItemLevel].EpicQuality[1]
                            else
                                SpellSourceItemBudget = 0
                            end
                            
                            if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then
                                
                                ScaledValue = math.ceil(SpellEffect.M_Average * SpellSourceItemBudget * max( CBDT.Player.Auras.PlayerAura[UNIT_AURA_STACKS], 1 ) - 0.5 )
                                
                            elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then
                                
                                ScaledValue = SpellEffect.M_Average * SpellSourceItemBudget * max( CBDT.Player.Auras.PlayerAura[UNIT_AURA_STACKS], 1 )
                            end
                        else
                            
                            if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then
                            
                                ScaledValue = math.ceil(SpellEffect.M_Average * CBDT.SpellEffectScaling[ SpellEffect.ScalingType ][ MaxScalingLevel ] * max( CBDT.Player.Auras.PlayerAura[UNIT_AURA_STACKS], 1 ) - 0.5)
                            
                            elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then
                                
                                ScaledValue = SpellEffect.M_Average * CBDT.SpellEffectScaling[ SpellEffect.ScalingType ][ MaxScalingLevel ] * max( CBDT.Player.Auras.PlayerAura[UNIT_AURA_STACKS], 1 )
                            end
                        end
                    end
                end
                
                --Обработка оставшегося времени баффа
                CurrentTime = GetTime()
                if CBDT.Player.Auras.PlayerAura[UNIT_AURA_EXPIRES] then

                    BuffRemains = CBDT.Player.Auras.PlayerAura[UNIT_AURA_EXPIRES] - CurrentTime
                    BuffExpires = CBDT.Player.Auras.PlayerAura[UNIT_AURA_EXPIRES]
                    
                    if BuffRemains < 0.0 then
                        BuffRemains = 0.0
                        BuffExpires = CurrentTime
                    end
                else
                    --Постоянный бафф
                    if CBDT.Player.Auras.PlayerAura[UNIT_AURA_DURATION] == 0 then
                        BuffRemains = 3600
                        BuffExpires = 3600 + CurrentTime
                    end
                end
                
                --Режим индексации - прямой
                if CBDT.SpellEffects[SpellEffect.Type].IndexMode == INDEX_MODE_DIRECT then
                    --Обрабатываем ли мы такую характеристику эффекта, например A_MOD_STAT[INTELLECT]
                    if CBDT.SpellEffects[SpellEffect.Type].SubTypes[SpellEffect.SubTypeIndex[CBDT.SpellEffects[SpellEffect.Type].SelectIndex]] then
                        --Дополнительная обработка эффектов имеющих прямую индексацию и эффект "Все параметры" (PSR_ALL_STATS)
                        if (SpellEffect.Type == A_MOD_STAT or SpellEffect.Type == A_MOD_PERCENT_STAT) and (CBDT.SpellEffects[SpellEffect.Type].SubTypes[SpellEffect.SubTypeIndex[CBDT.SpellEffects[SpellEffect.Type].SelectIndex]] == PSR_ALL_STATS) then
                            for PLAYER_STAT_INDEX = PSR_STRENGTH, PSR_SPIRIT do
                                
                                --Проверка на наличие баффа с таким SpellID и SpellEffect.Index
                                if not CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] then
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] = {}
                                end    
                                
                                if not CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] then
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] = {Buff_Type = TYPE_UNKNOWN, BuffValue = 0, BuffValuePct = 1.0, BuffRemains = 0.0, BuffExpires = 0.0, BuffName = "", Active = true, AffectingSpells = SpellEffect.AffectingSpells, AffectedSpells = SpellEffect.AffectedSpells}
                                else
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = true
                                end
                                    
                                if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then

                                    for AFFECTED_STAT_INDEX in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                        if not CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] then
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] = {}
                                        end    
                                        
                                        if not CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] then
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] = {Buff_Type = TYPE_UNKNOWN, BuffValue = 0, BuffValuePct = 1.0, BuffRemains = 0.0, BuffExpires = 0.0, BuffName = "", Active = true, AffectingSpells = SpellEffect.AffectingSpells, AffectedSpells = SpellEffect.AffectedSpells}
                                        else
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = true
                                        end
                                    end
                                end
                                
                                --Проверка на нулевое значение
                                if ScaledValue == 0 or BuffRemains == 0.0 then
                                    
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = false
                                    
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                        
                                        for AFFECTED_STAT_INDEX in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = false
                                        end
                                    end
                                end
                                
                                --Если характеристика аддитивная
                                if CBDT.Player.Stats[PLAYER_STAT_INDEX].Mode == MODE_ADD then
                                    --Простое значение
                                    if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then
                                        
                                        if not SpellEffect.AffectingSpells then
                                        
                                            CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                        else
                                            for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                                if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                    if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                        CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                                    end
                                                end
                                            end
                                        end
                                        
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ScaledValue
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                            
                                        if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                            
                                            for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                                
                                                if not SpellEffect.AffectingSpells then
                                                    
                                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue + ( ScaledValue * power_mod )

                                                end
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ( ScaledValue * power_mod )
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                            end
                                        end

                                    --Значение в процентах
                                    elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then
                                        
                                        if not SpellEffect.AffectingSpells then
                                        
                                            CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01)
                                        else
                                            for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                                if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                    if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                        CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01)
                                                    end
                                                end
                                            end
                                        end
                                        
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                            
                                        if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                            for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                                
                                                if not SpellEffect.AffectingSpells then
                                                    
                                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01) * power_mod
                                                end
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01 * power_mod
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                            end
                                        end
                                    end
                                --Если характеристика мультипликативная
                                elseif CBDT.Player.Stats[PLAYER_STAT_INDEX].Mode == MODE_MULT then
                                    --Простое значение
                                    if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then
                                        
                                        if not SpellEffect.AffectingSpells then
                                        
                                            CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                        else
                                            for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                                if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                    if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                        CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                                    end
                                                end
                                            end
                                        end
                                        
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ScaledValue
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                            
                                        if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                            for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                                
                                                if not SpellEffect.AffectingSpells then
                                                
                                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue + ( ScaledValue * power_mod )
                                                end
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ( ScaledValue * power_mod )
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                            end
                                        end
                                        
                                    --Значение в процентах
                                    elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then
                                        
                                        if not SpellEffect.AffectingSpells then
                                        
                                            CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01))
                                        else
                                            for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                                if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                    if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                        CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01))
                                                    end
                                                end
                                            end
                                        end

                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                            
                                        if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                            for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                                
                                                if not SpellEffect.AffectingSpells then
                                                    
                                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01)) * power_mod
                                                end
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01 * power_mod
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                            end
                                        end
                                    end
                                end
                        
                                --Отладочная информация
                                if CBDT.IsDebugEnabled then
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffString = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffString .. "\n" .. CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME] .. "(" .. SpellEffect.Type .. ")" .. "(" .. SpellEffect.Index .. ")"
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffName = CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]
                                    
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                        
                                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffString = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffString .. "\n" .. CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME] .. "(" .. SpellEffect.Type .. ")" .. "(" .. SpellEffect.Index .. ")"
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffName = CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]
                                        end
                                    end
                                end
                                
                                --Обновляем время действия баффа на выбранной характеристике игрока
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffRemains = BuffRemains
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffExpires = BuffExpires
                                
                                if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                
                                    for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffRemains = BuffRemains
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffExpires = BuffExpires
                                    end
                                end
                            end
                        --Штатная обработка одиночных эффектов
                        else
                            --Выбранная характеристика текущего баффа
                            PLAYER_STAT_INDEX = CBDT.SpellEffects[SpellEffect.Type].SubTypes[SpellEffect.SubTypeIndex[CBDT.SpellEffects[SpellEffect.Type].SelectIndex]]
                            
                            --Проверка на наличие баффа с таким SpellID и SpellEffect.Index
                            if not CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] then
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] = {}
                            end    
                            
                            if not CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] then
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] = {Buff_Type = TYPE_UNKNOWN, BuffValue = 0, BuffValuePct = 1.0, BuffRemains = 0.0, BuffExpires = 0.0, BuffName = "", Active = true, AffectingSpells = SpellEffect.AffectingSpells, AffectedSpells = SpellEffect.AffectedSpells}
                            else
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = true
                            end
                                
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then

                                for AFFECTED_STAT_INDEX in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                    if not CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] then
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] = {}
                                    end    
                                    
                                    if not CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] then
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] = {Buff_Type = TYPE_UNKNOWN, BuffValue = 0, BuffValuePct = 1.0, BuffRemains = 0.0, BuffExpires = 0.0, BuffName = "", Active = true, AffectingSpells = SpellEffect.AffectingSpells, AffectedSpells = SpellEffect.AffectedSpells}
                                    else
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = true
                                    end
                                end
                            end
                            
                            --Проверка на нулевое значение
                            if ScaledValue == 0 or BuffRemains == 0.0 then
                                
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = false
                                
                                for AFFECTED_STAT_INDEX in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = false
                                end
                            end
                            
                            --Если характеристика аддитивная
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].Mode == MODE_ADD then
                                --Простое значение
                                if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then
                                   
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                    else
                                        for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                            if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                    CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                                end
                                            end
                                        end
                                    end

                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ScaledValue
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                        
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                    
                                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            
                                            if not SpellEffect.AffectingSpells then
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue + ( ScaledValue * power_mod )
                                            end
                                            
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ( ScaledValue * power_mod )
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                        end
                                    end
                                --Значение в процентах
                                elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then
                                    
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01)
                                    else
                                        for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                            if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                    CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01)
                                                end
                                            end
                                        end
                                    end
                                    
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                        
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                    
                                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            
                                            if not SpellEffect.AffectingSpells then
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct + ((ScaledValue * 0.01) * power_mod)
                                            end
                                            
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01 * power_mod
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                        end
                                    end
                                end
                                
                            --Если характеристика мультипликативная
                            elseif CBDT.Player.Stats[PLAYER_STAT_INDEX].Mode == MODE_MULT then
                                --Простое значение
                                if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then
                                    
                                    if not SpellEffect.AffectingSpells then
                                        
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                    else
                                        for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                            if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                    CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                                end
                                            end
                                        end
                                    end
                                    
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ScaledValue
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                        
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                    
                                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            
                                            if not SpellEffect.AffectingSpells then
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue + ( ScaledValue * power_mod )
                                            end
                                            
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ( ScaledValue * power_mod )
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                        end
                                    end
                                    
                                --Значение в процентах
                                elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then
                                    
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01))
                                    else
                                        for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                            if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                    CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01))
                                                end
                                            end
                                        end
                                    end
                                    
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                        
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                    
                                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            
                                            if not SpellEffect.AffectingSpells then
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01)) * power_mod
                                            end
                                            
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01 * power_mod
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                        end
                                    end
                                end
                            end
                            
                            --Отладочная информация
                            if CBDT.IsDebugEnabled then
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffString = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffString .. "\n" .. CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME] .. "(" .. SpellEffect.Type .. ")" .. "(" .. SpellEffect.Index .. ")"
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffName = CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]
                            
                                if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                
                                    for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffString = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffString .. "\n" .. CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME] .. "(" .. SpellEffect.Type .. ")" .. "(" .. SpellEffect.Index .. ")"
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffName = CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]
                                    end
                                end
                            end
                            
                            --Обновляем время действия баффа на выбранной характеристике игрока
                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffRemains = BuffRemains
                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffExpires = BuffExpires
                            
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                            
                                for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffRemains = BuffRemains
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffExpires = BuffExpires
                                end
                            end
                        end
                    end
                
                --Режим индексации - битовая маска
                elseif CBDT.SpellEffects[SpellEffect.Type].IndexMode == INDEX_MODE_MASK then
                    --Обрабатываем ли мы характеристику эффекта с такой маской, например A_MOD_TOTAL_STAT_PERCENTAGE[INTELLECT_MASK]
                    for A_MOD_RATING_MASK, PLAYER_STAT_INDEX in pairs(CBDT.SpellEffects[SpellEffect.Type].SubTypes) do
                        if bit.band(SpellEffect.SubTypeIndex[CBDT.SpellEffects[SpellEffect.Type].SelectIndex], A_MOD_RATING_MASK) ~= 0 then
                            
                            --Проверка на наличие баффа с таким SpellID и SpellEffect.Index
                            if not CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] then
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] = {}
                            end    
                            
                            if not CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] then
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] = {Buff_Type = TYPE_UNKNOWN, BuffValue = 0, BuffValuePct = 1.0, BuffRemains = 0.0, BuffExpires = 0.0, BuffName = "", Active = true, AffectingSpells = SpellEffect.AffectingSpells, AffectedSpells = SpellEffect.AffectedSpells}
                            else
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = true
                            end
                                
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then

                                for AFFECTED_STAT_INDEX in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                    if not CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] then
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] = {}
                                    end    
                                    
                                    if not CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] then
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] = {Buff_Type = TYPE_UNKNOWN, BuffValue = 0, BuffValuePct = 1.0, BuffRemains = 0.0, BuffExpires = 0.0, BuffName = "", Active = true, AffectingSpells = SpellEffect.AffectingSpells, AffectedSpells = SpellEffect.AffectedSpells}
                                    else
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = true
                                    end
                                end
                            end
                            
                            --Проверка на нулевое значение
                            if ScaledValue == 0 or BuffRemains == 0.0 then
                                
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = false
                                
                                if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                
                                    for AFFECTED_STAT_INDEX in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = false
                                    end
                                end
                            end
                            
                            --Если характеристика аддитивная
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].Mode == MODE_ADD then
                                --Простое значение
                                if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then

                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                    else
                                        for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                            if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                    CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                                end
                                            end
                                        end
                                    end

                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ScaledValue
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                        
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                    
                                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            
                                            if not SpellEffect.AffectingSpells then
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue + ( ScaledValue * power_mod )
                                            end
                                            
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ( ScaledValue * power_mod )
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                        end
                                    end
                                    
                                --Значение в процентах
                                elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then
                                    
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01)
                                    else
                                        for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                            if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                    CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01)
                                                end
                                            end
                                        end
                                    end

                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                        
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                    
                                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            
                                            if not SpellEffect.AffectingSpells then
                                                
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01) * power_mod
                                            end
                                            
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01 * power_mod
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                        end
                                    end
                                end
                            --Если характеристика мультипликативная
                            elseif CBDT.Player.Stats[PLAYER_STAT_INDEX].Mode == MODE_MULT then
                                --Простое значение
                                if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then
                                    
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                    else
                                        for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                            if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                    CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                                end
                                            end
                                        end
                                    end

                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ScaledValue
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                        
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                    
                                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            
                                            if not SpellEffect.AffectingSpells then
                                            
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue + ( ScaledValue * power_mod )
                                            end
                                            
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ( ScaledValue * power_mod )
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                        end
                                    end
                                    
                                --Значение в процентах
                                elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then
                                    
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01))
                                    else
                                        for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                            if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                                if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                                    CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01))
                                                end
                                            end
                                        end
                                    end

                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01
                                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                        
                                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                    
                                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                            
                                            if not SpellEffect.AffectingSpells then
                                            
                                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01)) * power_mod
                                            end
                                            
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01 * power_mod
                                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                        end
                                    end
                                end
                            end
                            
                            --Отладочная информация
                            if CBDT.IsDebugEnabled then
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffString = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffString .. "\n" .. CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME] .. "(" .. SpellEffect.Type .. ")" .. "(" .. SpellEffect.Index .. ")"
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffName = CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]
                            
                                if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                                
                                    for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffString = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffString .. "\n" .. CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME] .. "(" .. SpellEffect.Type .. ")" .. "(" .. SpellEffect.Index .. ")"
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffName = CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]
                                    end
                                end
                            end
                            
                            --Обновляем время действия баффа на выбранной характеристике игрока
                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffRemains = BuffRemains
                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffExpires = BuffExpires
                            
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                            
                                for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffRemains = BuffRemains
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffExpires = BuffExpires
                                end
                            end
                            
                            --Эффект распространяется на все школы, нам достаточно одного срабатывания
                            if PLAYER_STAT_INDEX == PSR_DAMAGE_DONE_BONUS then
                                break
                            end
                        end
                    end
                
                --Режим индексации - любые значения
                elseif CBDT.SpellEffects[SpellEffect.Type].IndexMode == INDEX_MODE_ANY then
                    
                    PLAYER_STAT_INDEX = CBDT.SpellEffects[SpellEffect.Type].SubTypes["ANY"]
                    
                    --Проверка на наличие баффа с таким SpellID и SpellEffect.Index
                    if not CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] then
                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] = {}
                    end    
                    
                    if not CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] then
                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] = {Buff_Type = TYPE_UNKNOWN, BuffValue = 0, BuffValuePct = 1.0, BuffRemains = 0.0, BuffExpires = 0.0, BuffName = "", Active = true, AffectingSpells = SpellEffect.AffectingSpells, AffectedSpells = SpellEffect.AffectedSpells}
                    else
                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = true
                    end
                        
                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then

                        for AFFECTED_STAT_INDEX in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                            if not CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] then
                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]] = {}
                            end    
                            
                            if not CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] then
                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index] = {Buff_Type = TYPE_UNKNOWN, BuffValue = 0, BuffValuePct = 1.0, BuffRemains = 0.0, BuffExpires = 0.0, BuffName = "", Active = true, AffectingSpells = SpellEffect.AffectingSpells, AffectedSpells = SpellEffect.AffectedSpells}
                            else
                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = true
                            end
                        end
                    end
                    
                    --Проверка на нулевое значение
                    if ScaledValue == 0 or BuffRemains == 0.0 then
                        
                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = false
                        
                        if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                        
                            for AFFECTED_STAT_INDEX in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Active = false
                            end
                        end
                    end
                    
                    --Если характеристика аддитивная
                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].Mode == MODE_ADD then
                        --Простое значение
                        if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then
                            
                            if not SpellEffect.AffectingSpells then
                            
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                            else
                                for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                    if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                        if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                            CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                        end
                                    end
                                end
                            end

                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ScaledValue
                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                            
                                for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                    
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue + ( ScaledValue * power_mod )
                                    end
                                    
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ( ScaledValue * power_mod )
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                end
                            end
                            
                        --Значение в процентах
                        elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then

                            if not SpellEffect.AffectingSpells then
                            
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01)
                            else
                                for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                    if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                        if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                            CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01)
                                        end
                                    end
                                end
                            end

                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01
                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                            
                                for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                    
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct + (ScaledValue * 0.01) * power_mod
                                    end
                                    
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01 * power_mod
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                end
                            end
                        end
                    --Если характеристика мультипликативная
                    elseif CBDT.Player.Stats[PLAYER_STAT_INDEX].Mode == MODE_MULT then
                        --Простое значение
                        if CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_FLAT then
                            
                            if not SpellEffect.AffectingSpells then
                            
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                            else
                                for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                    if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                        if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                            CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValue + ScaledValue
                                        end
                                    end
                                end
                            end

                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ScaledValue
                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                            
                                for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                    
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValue + ( ScaledValue * power_mod )
                                    end
                                    
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValue = ( ScaledValue * power_mod )
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_FLAT
                                end
                            end
                        --Значение в процентах
                        elseif CBDT.SpellEffects[SpellEffect.Type].Type == TYPE_PERCENTAGE then
                            
                            if not SpellEffect.AffectingSpells then
                            
                                CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01))
                            else
                                for _, AffectedSpellID in ipairs (SpellEffect.AffectedSpells) do
                                    if CBDT.Player.DPEtSpells[AffectedSpellID] then
                                        if CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX] then
                                            CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct = CBDT.Player.DPEtSpells[AffectedSpellID].DamageStats[PLAYER_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01))
                                        end
                                    end
                                end
                            end
                            
                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01
                            CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                
                            if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                            
                                for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                    
                                    if not SpellEffect.AffectingSpells then
                                    
                                        CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffValuePct * (1.0 + (ScaledValue * 0.01)) * power_mod
                                    end
                                    
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffValuePct = ScaledValue * 0.01 * power_mod
                                    CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].Buff_Type = TYPE_PERCENTAGE
                                end
                            end
                        end
                    end
                    
                    --Отладочная информация
                    if CBDT.IsDebugEnabled then
                        CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffString = CBDT.Player.Stats[PLAYER_STAT_INDEX].BuffString .. "\n" .. CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME] .. "(" .. SpellEffect.Type .. ")" .. "(" .. SpellEffect.Index .. ")"
                        CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffName = CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]
                        
                        if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                        
                            for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffString = CBDT.Player.Stats[AFFECTED_STAT_INDEX].BuffString .. "\n" .. CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME] .. "(" .. SpellEffect.Type .. ")" .. "(" .. SpellEffect.Index .. ")"
                                CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffName = CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]
                            end
                        end
                    end
                    
                    --Обновляем время действия баффа на выбранной характеристике игрока
                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffRemains = BuffRemains
                    CBDT.Player.Stats[PLAYER_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffExpires = BuffExpires
                    
                    if CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectOnStats then
                    
                        for AFFECTED_STAT_INDEX, power_mod in pairs(CBDT.Player.Stats[PLAYER_STAT_INDEX].AffectedStats) do
                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffRemains = BuffRemains
                            CBDT.Player.Stats[AFFECTED_STAT_INDEX].Buffs[CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]][SpellEffect.Index].BuffExpires = BuffExpires
                        end
                    end
                end
            end
        end --for _, SpellEffect in ipairs(CBDT.SpellEffects[SpellID])
    end --if CBDT.SpellEffects[SpellID]               
end

function CBDT.Player:GetLevel(Unit)
    --Аргумент для выбора цели функции, добавлен в отладочных целях
    CBDT.Player.PlayerInfo.PlayerLevel = UnitLevel(Unit)
    
    --Возвращаемое значение может быть -1 в случае если цель ?? уровня
    if CBDT.Player.PlayerInfo.PlayerLevel <= 0 then
        CBDT.Player.PlayerInfo.PlayerLevel = UnitLevel("player")
    end
end

function CBDT.Player:GetBuffs()
    
    --Сбрасываем все характеристики и рейтинги, сбрасываем флаг активности у всех баффов
    for _, PlayerStat in pairs(CBDT.Player.Stats) do
        PlayerStat.BuffValue        = 0
        PlayerStat.BuffValuePct     = 1.0
        PlayerStat.BuffedValue      = 0
        PlayerStat.BuffedValuePct   = 1.0
        PlayerStat.BaseValue        = 0
        PlayerStat.BaseValuePct     = 1.0
        PlayerStat.BuffString       = ""
        
        for BuffSpellID in pairs(PlayerStat.Buffs) do
            for BuffSpellEffectIndex in pairs (PlayerStat.Buffs[BuffSpellID]) do
                PlayerStat.Buffs[BuffSpellID][BuffSpellEffectIndex].Active = false
            end
        end
    end

    --Сбрасываем все характеристики у DPET-заклинаний
    for _, DPEtSpell in pairs ( CBDT.Player.DPEtSpells ) do
        for STAT_INDEX, DamageStat in pairs ( DPEtSpell.DamageStats ) do
            DamageStat.BuffValue        = 0
            DamageStat.BuffValuePct     = 1.0
        end
    end
            
            
    
    if UnitExists(SelectedUnit) then
       
        for PlayerAuraIndex = 1, 40 do
            
            CBDT.Player.Auras.PlayerAura = {UnitAura(SelectedUnit, PlayerAuraIndex)}
            CBDT.Player.Auras.PlayerAuraIndex = PlayerAuraIndex
            
            if CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME] then
                
                CBDT.Player.PlayerInfo.GetSpecBuffs()
                
                CBDT.Player:ProcessBuffs()

            else
                --Эмулируем баффы, которые скрыты или являются пассивными
                
                if CBDT.IsBuffSimulationEnabled then
                    
                    for Index, SimulatedAura in pairs ( CBDT.Player.Auras.SimulatedPlayerAuras ) do
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]                = SimulatedAura[UNIT_AURA_NAME]
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_EXPIRES]             = GetTime() + 6.0 + ( Index * 2 )
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]            = SimulatedAura[UNIT_AURA_SPELL_ID]
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_STACKS]              = SimulatedAura[UNIT_AURA_STACKS]
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_VALUE_OFFSET + 0]    = 0
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_VALUE_OFFSET + 1]    = 0
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_VALUE_OFFSET + 2]    = 0
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_VALUE_OFFSET + 3]    = 0
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_VALUE_OFFSET + 4]    = 0
                        
                        CBDT.Player:ProcessBuffs()
                        CBDT.Player.PlayerInfo.GetSpecBuffs()
                    end
                else
                    for Index, SimulatedAura in pairs ( CBDT.Player.Auras.SimulatedPlayerAuras ) do
                        CBDT.Player.Auras.SimulatedPlayerAuras[Index] = nil
                    end
                end
                
                --Эмуляция бонусов от комплектов брони
                for _, Tier in pairs ( CBDT.Player.GearSpecific.TierArmorSets ) do
                    
                    if Tier.TierBonus4P.Active then
                       
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]            = Tier.TierBonus4P.SpellName
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]        = Tier.TierBonus4P.SpellID
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_STACKS]          = Tier.TierBonus4P.SpellStacks
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_DURATION]        = Tier.TierBonus4P.SpellDuration
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_EXPIRES]         = Tier.TierBonus4P.SpellDuration + GetTime()
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_VALUE_OFFSET]    = 0
                        
                        CBDT.Player:ProcessBuffs()
                    end
                    
                    if Tier.TierBonus2P.Active then
                        
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_NAME]            = Tier.TierBonus2P.SpellName
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_SPELL_ID]        = Tier.TierBonus2P.SpellID
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_STACKS]          = Tier.TierBonus2P.SpellStacks
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_DURATION]        = Tier.TierBonus2P.SpellDuration
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_EXPIRES]         = Tier.TierBonus2P.SpellDuration + GetTime()
                        CBDT.Player.Auras.PlayerAura[UNIT_AURA_VALUE_OFFSET]    = 0
                        
                        CBDT.Player:ProcessBuffs()
                    end
                end
                
                break
            end
        end
    end
end

function CBDT.Player:UpdateBuffDurations()

    local CurrentTime = 0
    
    if not CBDT.IsEnabled then
        return
    end
    
    CurrentTime = GetTime()
    
    for _, PlayerStat in pairs(CBDT.Player.Stats) do
        for _, Buff in pairs(PlayerStat.Buffs) do
            for _, BuffSpellEffect in pairs (Buff) do
                if BuffSpellEffect.Active then
                    if CurrentTime >= BuffSpellEffect.BuffExpires then
                        BuffSpellEffect.BuffRemains = 0.0
                        BuffSpellEffect.Active = false
                    else
                        BuffSpellEffect.BuffRemains = BuffSpellEffect.BuffExpires - CurrentTime
                    end
                else
                    BuffSpellEffect.BuffRemains = 0.0
                end
            end
        end
    end
end

local function CBDT_EventFrame_OnUpdate(Self, Elapsed)
    
    CBDT.TimeSinceLastUpdate = CBDT.TimeSinceLastUpdate + Elapsed
  
    if CBDT.TimeSinceLastUpdate > CBDT.UpdateInterval then
   
        CBDT.Player:UpdateBuffDurations()
        
        CBDT.Player:ProcessDPEtSpells()
        
        CBDT.StageDisplay:Update()
        
        CBDT.StageDisplay:PrimarySpellNotification()
        
        CBDT:DebugPrintout()
        
        CBDT.TimeSinceLastUpdate = 0
    end
end 

function CBDT:AddonTurnOnOff()
    
    if UnitIsDead(SelectedUnit) or UnitIsGhost(SelectedUnit) or ( CBDT.Player.PlayerInfo.PlayerSpec ~= CBDT.WARLOCK_DESTRUCTION ) then
        CBDT.IsEnabled = false
    else
        CBDT.IsEnabled = true
    end
    
end

function CBDT:DebugPrintout()

    if CBDT.IsDebugEnabled then
        
        local SpellEffectString = ""
        local msg = ""
        
        for _, PlayerStat in pairs(CBDT.Player.Stats) do
            if (PlayerStat.BuffValue ~= 0 or PlayerStat.BuffValuePct > 1.0 or PlayerStat.BuffString ~= "") then
                if PlayerStat.Type == TYPE_FLAT then
                    SpellEffectString = SpellEffectString .. format("Name: %s\nBuffedValue: %d | BaseValue: %d | BuffValue: %d | BuffValuePct(%%): %2.1f | Buffs: %s\n\n", PlayerStat.Name, PlayerStat.BuffedValue, PlayerStat.BaseValue, PlayerStat.BuffValue, PlayerStat.BuffValuePct*100, PlayerStat.BuffString)
                else
                    SpellEffectString = SpellEffectString .. format("Name: %s\nBuffedValuePct(%%): %2.1f | BaseValuePct(%%): %2.1f | BuffValue: %d | BuffValuePct(%%): %2.1f | Buffs: %s\n\n", PlayerStat.Name, PlayerStat.BuffedValuePct*100, PlayerStat.BaseValuePct*100, PlayerStat.BuffValue, PlayerStat.BuffValuePct*100, PlayerStat.BuffString)
                end
            end
        end

        CBDT_EventFrame.Text:SetText(SpellEffectString)
        

        msg = format("Target Health: %d\nEmberkill threshold: %2.2f\nPlayer is in raid: %s\nPlayer is in party: %s\nGroup members number: %d\nDamagers on players target: %2.1f\nGroup members:\n",
            CBDT.Player.Target.TargetHealth,
            CBDT.Player.Target.TargetEmberKillThreshold,
            CBDT.Player.GroupInfo.IsInRaid and "true" or "false",
            CBDT.Player.GroupInfo.IsInGroup and "true" or "false",
            CBDT.Player.GroupInfo.GroupMembersNumber,
            CBDT.Player.GroupInfo.DamagersOnPlayersTarget )
            
        for GroupMemberName, GroupMember in pairs( CBDT.Player.GroupInfo.GroupMember ) do
            if GroupMember.Active then
                msg = msg .. format("Name: %s, Role: %s, TargetGUID: %s\n", GroupMemberName, GroupMember.Role, string.sub(GroupMember.TargetGUID or "", 1, 10) )
            end
        end
        
        CBDT_EventFrame.DebugTextRight:SetText(msg)
    end
end

local function CBDT_EventFrame_OnEvent(Self, Event, Unit, ... )
    
    local SpellID = 0
   
    if Unit == SelectedUnit and ( 
            Event == "UNIT_AURA" or
            Event == "COMBAT_RATING_UPDATE" or
            Event == "PLAYER_DAMAGE_DONE_MODS" or
            Event == "UNIT_STATS" or
            Event == "UNIT_SPELL_HASTE" or
            Event == "MASTERY_UPDATE" ) then
        
        CBDT.Player:GetBuffs()
        CBDT.Player:GetBaseStats()

    elseif Event == "PLAYER_DEAD" or Event == "PLAYER_ALIVE" or Event == "PLAYER_UNGHOST" then
        
        CBDT:AddonTurnOnOff()
    
    elseif Event == "PLAYER_LEVEL_UP" or Event == "PLAYER_ENTERING_WORLD" then
        
        CBDT.Player:GetLevel(SelectedUnit)
        CBDT.Player:GetPlayerInfo()
        CBDT.Player:GetMetagemCritEffect()
        CBDT.Player:GetAmplificationEffect()
        CBDT.Player:GetEquipmentInfo()
        CBDT.Player:GetTierBonuses()
        
        CBDT.Player:GetBuffs()
        CBDT.Player:GetBaseStats()
        
        CBDT:AddonTurnOnOff()
    
    elseif Event == "ACTIVE_TALENT_GROUP_CHANGED" or Event == "PLAYER_SPECIALIZATION_CHANGED" then
    
        CBDT.Player:GetPlayerInfo()
        
        CBDT:AddonTurnOnOff()
       
    elseif Event == "PLAYER_EQUIPMENT_CHANGED" or Event == "PLAYER_AVG_ITEM_LEVEL_UPDATE" then
        
        CBDT.Player:GetMetagemCritEffect()
        CBDT.Player:GetAmplificationEffect()
        CBDT.Player:GetEquipmentInfo()
        CBDT.Player:GetTierBonuses()
    
    elseif Event == "ADDON_LOADED" and Unit == CBDT.ADDON_NAME then
        if not CBDT_SavedOptions then
            
            CBDT_SavedOptions = {}
            
            CBDT_SavedOptions.DPEtHighThresholdPct          = CBDT.StageDisplay.DPEtHighThresholdPct.Current
            CBDT_SavedOptions.DPEtLowThresholdPct           = CBDT.StageDisplay.DPEtLowThresholdPct.Current
            CBDT_SavedOptions.TimeWindow                    = CBDT.StageDisplay.TimeWindow.Current
            CBDT_SavedOptions.Stages                        = CBDT.StageDisplay.Stages.Current
            
            CBDT_SavedOptions.StageBarWidth                 = CBDT.StageDisplay.StageBarWidth.Current
            CBDT_SavedOptions.StageBarHeight                = CBDT.StageDisplay.StageBarHeight.Current
            CBDT_SavedOptions.StageBarOffsetX               = CBDT.StageDisplay.StageBarOffsetX.Current
            CBDT_SavedOptions.StageBarOffsetY               = CBDT.StageDisplay.StageBarOffsetY.Current
            
            CBDT_SavedOptions.ShowStage1Description         = CBDT.StageDisplay.StageBars[1].Description.Active
            CBDT_SavedOptions.ShowStage2Description         = CBDT.StageDisplay.StageBars[2].Description.Active
            
            CBDT_SavedOptions.StageDescriptionFontSize      = CBDT.StageDisplay.StageDescriptionFontSize.Current
            
            CBDT_SavedOptions.ShowCastLine                  = CBDT.StageDisplay.DPEtSpellCastLine.Active
            
            CBDT_SavedOptions.UseBackdraftStacks            = CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].Backdraft.UseBackdraftStacks

            CBDT_SavedOptions.UseEmberKillOnTrashTargets    = CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].UseEmberKillOnTrashTargets

            CBDT_SavedOptions.SelectedChaosBoltSoundIndex   = CBDT.SoundNotification.SelectedChaosBoltSoundIndex
            CBDT_SavedOptions.SelectedShadowburnSoundIndex  = CBDT.SoundNotification.SelectedShadowburnSoundIndex
            CBDT_SavedOptions.SelectedSoundChannel          = CBDT.SoundNotification.SelectedSoundChannel
        
        else
            CBDT.StageDisplay.DPEtHighThresholdPct.Current                                  = CBDT_SavedOptions.DPEtHighThresholdPct
            CBDT.StageDisplay.DPEtLowThresholdPct.Current                                   = CBDT_SavedOptions.DPEtLowThresholdPct
            CBDT.StageDisplay.TimeWindow.Current                                            = CBDT_SavedOptions.TimeWindow
            CBDT.StageDisplay.Stages.Current                                                = CBDT_SavedOptions.Stages
            
            CBDT.StageDisplay.StageBarWidth.Current                                         = CBDT_SavedOptions.StageBarWidth
            CBDT.StageDisplay.StageBarHeight.Current                                        = CBDT_SavedOptions.StageBarHeight
            CBDT.StageDisplay.StageBarOffsetX.Current                                       = CBDT_SavedOptions.StageBarOffsetX
            CBDT.StageDisplay.StageBarOffsetY.Current                                       = CBDT_SavedOptions.StageBarOffsetY
            
            CBDT.StageDisplay.StageBars[1].Description.Active                               = CBDT_SavedOptions.ShowStage1Description
            CBDT.StageDisplay.StageBars[2].Description.Active                               = CBDT_SavedOptions.ShowStage2Description
            
            CBDT.StageDisplay.StageDescriptionFontSize.Current                              = CBDT_SavedOptions.StageDescriptionFontSize
            
            CBDT.StageDisplay.DPEtSpellCastLine.Active                                      = CBDT_SavedOptions.ShowCastLine
            
            CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].Backdraft.UseBackdraftStacks   = CBDT_SavedOptions.UseBackdraftStacks
            
            CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].UseEmberKillOnTrashTargets     = CBDT_SavedOptions.UseEmberKillOnTrashTargets
            
            CBDT.SoundNotification.SelectedChaosBoltSoundIndex                              = CBDT_SavedOptions.SelectedChaosBoltSoundIndex
            CBDT.SoundNotification.SelectedShadowburnSoundIndex                             = CBDT_SavedOptions.SelectedShadowburnSoundIndex
            CBDT.SoundNotification.SelectedSoundChannel                                     = CBDT_SavedOptions.SelectedSoundChannel
        end
    elseif Unit == SelectedUnit and Event == "UNIT_POWER_FREQUENT" and ... == "BURNING_EMBERS" then
        
        CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].BurningEmberBits = UnitPower(SelectedUnit,SPELL_POWER_BURNING_EMBERS, true)
    
    elseif Event == "PLAYER_TARGET_CHANGED" then
        
        CBDT.Player:GetTargetInfo()
        
        CBDT.SoundNotification.Replay.Pending = true
        CBDT.SoundNotification.Replay.CurrentEventSource = NSR_TARGET_CHANGED
    
    elseif Unit == "target" and Event == "UNIT_HEALTH_FREQUENT" then
        
        CBDT.Player:GetTargetInfo()
    
    elseif Event == "RAID_ROSTER_UPDATE" or Event == "GROUP_ROSTER_UPDATE" then
        
        if IsInRaid() then
            
            CBDT.Player.GroupInfo.IsInRaid  = true
            CBDT.Player.GroupInfo.IsInGroup = false
            
        elseif IsInGroup() then
            
            CBDT.Player.GroupInfo.IsInRaid  = false
            CBDT.Player.GroupInfo.IsInGroup = true
            
        else
            
            CBDT.Player.GroupInfo.IsInRaid  = false
            CBDT.Player.GroupInfo.IsInGroup = false
            
        end
        
        CBDT.Player:GetGroupInfo()
    
    elseif Event == "ROLE_CHANGED_INFORM" or Event == "PLAYER_ROLES_ASSIGNED" then
    
        CBDT.Player:GetGroupInfo()
       
    elseif Event == "UNIT_TARGET" and Unit ~= "player" then
        
        if ( string.sub( Unit, 1, 4 ) == "raid" ) or ( string.sub( Unit, 1, 5 ) == "party" ) then
            CBDT.Player:UpdateGroupTargetInfo( Unit )
        end
        
    elseif Unit == "player" and ( Event == "UNIT_SPELLCAST_SUCCEEDED" or Event == "UNIT_SPELLCAST_STOP" ) then
    
        SpellID = select(4, ...)
        if Event == "UNIT_SPELLCAST_SUCCEEDED" then
            
            if SpellID == DPET_CHAOS_BOLT_SPELL_ID or SpellID == DPET_SHADOW_BURN_SPELL_ID then
                
                CBDT.SoundNotification.Replay.Pending = true
                CBDT.SoundNotification.Replay.CurrentEventSource  = NSR_SUCCEEDED_SPELLCAST
            end
        elseif Event == "UNIT_SPELLCAST_STOP" then
            
            if ( SpellID == DPET_CHAOS_BOLT_SPELL_ID or SpellID == DPET_SHADOW_BURN_SPELL_ID ) then
               
                if ( CBDT.SoundNotification.Replay.CurrentEventSource ~= NSR_SUCCEEDED_SPELLCAST ) and CBDT.Player.PlayerIsMoving then
                    
                    CBDT.SoundNotification.Replay.Pending  = false
                    CBDT.SoundNotification.Replay.CurrentEventSource  = NSR_INTERRUPTED_SPELLCAST
                
                elseif CBDT.Player.PlayerIsMoving then
                    
                    CBDT.SoundNotification.Replay.Pending  = true
                    CBDT.SoundNotification.Replay.CurrentEventSource  = NSR_INTERRUPTED_SPELLCAST
                end
            end
        end
        
    elseif Event == "GET_ITEM_INFO_RECEIVED" then
        
        if CBDT.Player.Equipment.EquipmentInfoUpdatePending then
            CBDT.Player:GetEquipmentInfo()
            CBDT.Player:GetTierBonuses()
        end
        
    elseif Event == "PLAYER_STOPPED_MOVING" then
       
        if CBDT.SoundNotification.Replay.CurrentEventSource == NSR_INTERRUPTED_SPELLCAST and CBDT.Player.PlayerIsMoving then
            CBDT.SoundNotification.Replay.Pending  = true
            CBDT.SoundNotification.Replay.CurrentEventSource  = NSR_STAND_STILL
        end
        
        CBDT.Player.PlayerIsMoving = false
        
    elseif Event == "PLAYER_STARTED_MOVING" then
        
        CBDT.Player.PlayerIsMoving = true
        
    end
end

function CBDT.Player:GetTargetInfo()
	CBDT.Player.Target.TargetGUID = UnitGUID("target") or 0
    CBDT.Player.Target.TargetHealth = UnitHealth("target")
    CBDT.Player.Target.TargetHealthMax = UnitHealthMax("target")
    CBDT.Player.Target.TargetHealthPct = ( CBDT.Player.Target.TargetHealth / CBDT.Player.Target.TargetHealthMax ) * 100.0
	CBDT.Player.Target.TargetIsAttackable = UnitCanAttack("player", "target")
end

local function CommandLineHandler(msg)
    
    local command, params = msg:match("^(%S*)%s*(.-)$")
    local SpellID = 0
    local SpellName = ""

    if command == "debug" then
        
        CBDT.IsDebugEnabled = not CBDT.IsDebugEnabled

        
        if CBDT.IsDebugEnabled then
            CBDT_EventFrame.Text:Show()
            CBDT_EventFrame.DebugText:Show()
            CBDT_EventFrame.DebugTextRight:Show()
            print(format("|cff9482c9%s debug messages enabled.|r", CBDT.ADDON_NAME ))
        else
            CBDT_EventFrame.Text:SetText("")
            CBDT_EventFrame.DebugText:SetText("")
            CBDT_EventFrame.DebugTextRight:SetText("")
            CBDT_EventFrame.Text:Hide()
            CBDT_EventFrame.DebugText:Hide()
            CBDT_EventFrame.DebugTextRight:Hide()
            print(format("|cff9482c9%s debug messages disabled.|r", CBDT.ADDON_NAME ))
        end
    
    elseif command == "simulate" then
        
        if params == "off" then
            
            CBDT.IsBuffSimulationEnabled = false
            print(format("|cff9482c9%s buff simulation disabled.|r", CBDT.ADDON_NAME ))
        else
            
            local Index = 1
            
            for InputSpellID in string.gmatch(params, "%d+") do
                SpellID = tonumber( InputSpellID )
                SpellName = GetSpellInfo( SpellID )
            
                if SpellID and SpellID > 0 and SpellName then
                    
                    if not CBDT.Player.Auras.SimulatedPlayerAuras[Index] then
                        CBDT.Player.Auras.SimulatedPlayerAuras[Index] = {}
                    end
                    
                    CBDT.Player.Auras.SimulatedPlayerAuras[Index][UNIT_AURA_NAME] = SpellName
                    CBDT.Player.Auras.SimulatedPlayerAuras[Index][UNIT_AURA_SPELL_ID] = SpellID
                    CBDT.Player.Auras.SimulatedPlayerAuras[Index][UNIT_AURA_STACKS] = 1
                    
                    CBDT.IsBuffSimulationEnabled = true
                    print(format("|cff9482c9%s buff simulation for SpellID %s - %s |cff9482c9enabled.|r", CBDT.ADDON_NAME, SpellID, GetSpellLink(SpellID) ))
                else
                    CBDT.IsBuffSimulationEnabled = false
                    print(format("|cff9482c9%s incorrect SpellID(s) provided.\nType %s simulate SpellID1 SpellID2 |r", CBDT.ADDON_NAME, SLASH_CBDT1 ))
                    break
                end
                
                Index = Index + 1
            end
        end
    
    elseif command == "testmode" then
        
        CBDT.IsTestModeEnabled = not CBDT.IsTestModeEnabled
        if CBDT.IsTestModeEnabled then
            print(format("|cff9482c9%s test mode enabled.|r", CBDT.ADDON_NAME ))
        else
            print(format("|cff9482c9%s test mode disabled.|r", CBDT.ADDON_NAME ))
        end
    
    elseif command == "disable" then
        
        CBDT.IsEnabled = false
        print(format("|cff9482c9%s disabled.|r", CBDT.ADDON_NAME ))
    
    elseif command == "enable" then
   
        CBDT.IsEnabled = true
        print(format("|cff9482c9%s enabled.|r", CBDT.ADDON_NAME ))
   
    else
        CBDT_OptionsFrame.DPEtHighThresholdPct:SetText(CBDT.StageDisplay.DPEtHighThresholdPct.Current * 100.0)
        CBDT_OptionsFrame.DPEtLowThresholdPct:SetText(CBDT.StageDisplay.DPEtLowThresholdPct.Current * 100.0)
        CBDT_OptionsFrame.TimeWindow:SetText(CBDT.StageDisplay.TimeWindow.Current)
        CBDT_OptionsFrame.Stages:SetText(CBDT.StageDisplay.Stages.Current)
        
        CBDT_OptionsFrame.StageBarWidth:SetText(CBDT.StageDisplay.StageBarWidth.Current)
        CBDT_OptionsFrame.StageBarHeight:SetText(CBDT.StageDisplay.StageBarHeight.Current)
        CBDT_OptionsFrame.StageBarOffsetX:SetText(CBDT.StageDisplay.StageBarOffsetX.Current)
        CBDT_OptionsFrame.StageBarOffsetY:SetText(CBDT.StageDisplay.StageBarOffsetY.Current)
        
        CBDT_OptionsFrame.ShowStage1Description:SetChecked(CBDT.StageDisplay.StageBars[1].Description.Active)
        CBDT_OptionsFrame.ShowStage2Description:SetChecked(CBDT.StageDisplay.StageBars[2].Description.Active)
        
        CBDT_OptionsFrame.StageDescriptionFontSize:SetText(CBDT.StageDisplay.StageDescriptionFontSize.Current)
        
        CBDT_OptionsFrame.ShowCastLine:SetChecked(CBDT.StageDisplay.DPEtSpellCastLine.Active)
        
        CBDT_OptionsFrame.UseBackdraftStacks:SetChecked(CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].Backdraft.UseBackdraftStacks)
        
        CBDT_OptionsFrame.UseEmberKillOnTrashTargets:SetChecked(CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].UseEmberKillOnTrashTargets)
        
        CBDT_OptionsFrame:Show()
    end
end

function CBDT_EventFrame_OnLoad()
    CBDT_EventFrame.Text = CBDT_EventFrame:CreateFontString();
    CBDT_EventFrame.Text:SetPoint("TOP",0,100);
    CBDT_EventFrame.Text:SetFont("Fonts\\FRIZQT___CYR.ttf", 10, "")
    CBDT_EventFrame.Text:SetJustifyH("LEFT")
    CBDT_EventFrame.Text:Hide()

    CBDT_EventFrame.DebugText = CBDT_EventFrame:CreateFontString();
    CBDT_EventFrame.DebugText:SetPoint("TOPLEFT",-450,0);
    CBDT_EventFrame.DebugText:SetFont("Fonts\\FRIZQT___CYR.ttf", 10, "")
    CBDT_EventFrame.DebugText:SetJustifyH("LEFT")
    CBDT_EventFrame.DebugText:Hide()
    
    CBDT_EventFrame.DebugTextRight = CBDT_EventFrame:CreateFontString();
    CBDT_EventFrame.DebugTextRight:SetPoint("TOPRIGHT",300,-20);
    CBDT_EventFrame.DebugTextRight:SetFont("Fonts\\FRIZQT___CYR.ttf", 10, "")
    CBDT_EventFrame.DebugTextRight:SetJustifyH("LEFT")
    CBDT_EventFrame.DebugTextRight:Hide()
    
    CBDT_EventFrame:RegisterEvent("ADDON_LOADED")
    
    CBDT_EventFrame:RegisterEvent("UNIT_AURA")
    CBDT_EventFrame:RegisterEvent("COMBAT_RATING_UPDATE")
    CBDT_EventFrame:RegisterEvent("PLAYER_DAMAGE_DONE_MODS")
    CBDT_EventFrame:RegisterEvent("UNIT_STATS")
    CBDT_EventFrame:RegisterEvent("UNIT_SPELL_HASTE")
    CBDT_EventFrame:RegisterEvent("MASTERY_UPDATE")
    
    CBDT_EventFrame:RegisterEvent("PLAYER_LEVEL_UP")
    
    CBDT_EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
    
    CBDT_EventFrame:RegisterEvent("PLAYER_EQUIPMENT_CHANGED")
    CBDT_EventFrame:RegisterEvent("PLAYER_AVG_ITEM_LEVEL_UPDATE")
    
    CBDT_EventFrame:RegisterEvent("UNIT_POWER_FREQUENT")
    
    CBDT_EventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
    CBDT_EventFrame:RegisterEvent("UNIT_TARGET")
    
    CBDT_EventFrame:RegisterEvent("UNIT_HEALTH_FREQUENT")
    
    CBDT_EventFrame:RegisterEvent("RAID_ROSTER_UPDATE")
    CBDT_EventFrame:RegisterEvent("GROUP_ROSTER_UPDATE")
    CBDT_EventFrame:RegisterEvent("PARTY_MEMBERS_CHANGED")
    
    CBDT_EventFrame:RegisterEvent("ROLE_CHANGED_INFORM")
    CBDT_EventFrame:RegisterEvent("PLAYER_ROLES_ASSIGNED")
    
    CBDT_EventFrame:RegisterEvent("PLAYER_DEAD")
    CBDT_EventFrame:RegisterEvent("PLAYER_ALIVE")
    CBDT_EventFrame:RegisterEvent("PLAYER_UNGHOST")
    
    CBDT_EventFrame:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
    CBDT_EventFrame:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
    
    CBDT_EventFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
    CBDT_EventFrame:RegisterEvent("UNIT_SPELLCAST_STOP")
    CBDT_EventFrame:RegisterEvent("PLAYER_STOPPED_MOVING")
    CBDT_EventFrame:RegisterEvent("PLAYER_STARTED_MOVING")    
    
    CBDT_EventFrame:RegisterEvent("GET_ITEM_INFO_RECEIVED")
       
    CBDT_EventFrame:SetScript("OnEvent", CBDT_EventFrame_OnEvent)
    CBDT_EventFrame:SetScript("OnUpdate", CBDT_EventFrame_OnUpdate)
    
    SlashCmdList["CBDT"] = CommandLineHandler
    
    print(format("|cff9482c9%s-%s loaded!|r", CBDT.ADDON_NAME, CBDT.ADDON_VERSION))
    print(format("|cff9482c9To open the options window, type|r %s", SLASH_CBDT1))
end